#include "stdafx.h"

#include "yaneAppBase.h"
#include "yaneAppManager.h"
#include "yaneAppInitializer.h"

//	IAppBase*	IAppBase::m_lpMainApp=NULL;

//////////////////////////////////////////////////////////////////////////////

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

CAppBase::CAppBase() {
	m_bIdle		=	false;
	m_bMessage	=	false;
	m_bWaitIfMinimized = false;
	m_bClose	=	false;	//	OnPreClose𖳎CloseԂȂ̂H
	m_hAccel	=	NULL;
	m_bMainApp	=	false;

	CAppManager::Inc();	//	QƃJEg̃CNg
}

CAppBase::~CAppBase() {
	StopThread();
	CAppManager::Dec();	//	QƃJEg̃fNg
	//	̃NX́ACThreadhNXȂ̂ŁA
	//	DecStopThreadɂȂĂ܂B
	//	āAsāAStopThreadĂяoƂɂāA
	//	Xbh̒~ۏ؂B
}

//////////////////////////////////////////////////////////////////////////////

LRESULT CAppBase::OnPreCreate(CWindowOption& opt){

	opt.caption		= "Ղ肿";
	opt.classname	= "YANEAPPLICATION";
	opt.size_x		= 640;
	opt.size_y		= 480;
	opt.style		= WS_MINIMIZEBOX | WS_CAPTION | WS_SYSMENU;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////

LRESULT CAppBase::Run(){
	//	ꂪCX^XȂ΁AeEBhDƂ݂Ȃ
//	if (m_lpMainApp==NULL) m_lpMainApp = this;
	/**
		EBhDɎ]֌W͂ȂȂ̂
		CƂTuƂʎ̂Ȃ
	*/

/*
	if (IsMainApp()) {
		return JumpToThread();
	}
	//	CEBhDȊOȂ΁ApɃXbh遫
*/
	/**
		̃t[yaneSDK3rdł͔p~
		KXbh𐶐悤ɕύX
	*/

	m_nThreadStatus = -1;
	if (CreateThread()) return 1;

	//	EBhD̊܂ő҂
	while (true){
		if (m_bMessage || m_nThreadStatus>=0) break;
		::Sleep(100);
	}
	return 0;
}

//	ꂪ쐬ꂽCXbh
void CAppBase::ThreadProc(){		//	override from CThread
	//	EBhD̍쐬WorkThread̍쐬MessageLoop
	if (OnInit()) return ;
	CWindowOption opt;
	if (OnPreCreate(opt)) return ;			//	EBhDOɌĂяo
	if (m_oWindow.Create(opt)) return ;		//	EBhD̍쐬
	if (OnCreate()) return ;				//	EBhDĂĂяo
	CAppManager::Add(this);					//	CAppBase̓o^
	CAppManager::Hook(this);				//	bZ[WtbNJn
	m_bMessage = true;						//	ƃEBhD͊
	MainThread();							//	[U[ŗpӂꂽAC֐
	m_bMessage = false;						//	EBhD͔j󂳂̂...
	OnDestroy();							//	IO
	//	Threadapp𔻕ʂĂ̂HookThreadDelȂĂ͂ȂȂ
	//	::SendMessage(GetHWnd(),WM_CLOSE,0,0);	//	bZ[WXbh~

	//	::SendMessage(GetHWnd(),WM_DESTROY,0,0);	//	bZ[WXbh~
	//	KvȂ񂩁HHꂢĂƁAXbhfbhbNƂDD

	::PostMessage(GetHWnd(),WM_DESTROY,0,0);	//	bZ[WXbh~
	MessagePump(true);	//	œbZ[W̏
	//	ɂĂ͎sȂƁAEBhD̎c[c邱Ƃ

	//	WM_DestoryȂĂ͂ȂȂ̂łŃtbN
	CAppManager::Unhook(this);				//	bZ[WtbN̏I

	/*
		CAppManager؂藣ƁAStopThreadOɁA
		I肪sȂAXbhc\B
		āACThread̑SẴXbhÎmFĂ~ׂ
	*/

	CAppManager::Del(this);					//	CAppBase̍폜
	InnerStopThread();						//	Xbh~
}

LRESULT CAppBase::MessagePump(bool bPeek/*=true*/){
	MSG msg;
	HWND hWnd = GetHWnd();
	if (bPeek) {
		while (::PeekMessage(&msg, NULL /* hWnd */,0,0,PM_REMOVE)) {
			//	˂AhWndɂȂƃ}`EBhDɂƂA}YĈA
			//@ǂANULLEBhDɂłȂbZ[W悤...
			//	bZ[W݂菈Â
			if(::TranslateAccelerator(hWnd,m_hAccel,&msg)==0) {
				::TranslateMessage(&msg); 
				::DispatchMessage(&msg);
			}
		}
		//	SɂȂAPeekMessageG[IĂȂׂׂȂ̂mȂ
		//	GetMessageɑ΂Ė߂l-1ǂ`FbNĂ킯ŁAPeekMessageɂĂ
		//	ɑΉ鏈Kvƍl
		return 0;
	} else {
		LRESULT lr = ::GetMessage(&msg,NULL,0,0);
		//	˂AGetHWndɂȂƃ}`EBhDɂƂA}YĈA
		//@ǂANULLEBhDɂłȂbZ[W悤...
		if (lr!=-1) {
			//	G[R[hԂĂĂꍇA
			//	dispatchĂ͂ȂB
			//	ȀꍇAAvIׂ낤H
			if(::TranslateAccelerator(hWnd,m_hAccel,&msg)==0) {
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
		} else {
			// -1ԂĂȂÃXbhjق񂶂ˁH
			InvalidateThread();
		}
		return lr;
	}
}

bool CAppBase::IsThreadValid()	{

	GetIntervalTimer()->CallBack();
	//	tbNĂ^C}ɃR[obN

	if ( m_bIdle ){
		// Idle[hǉ
		MessagePump(false); // get
	}else{
		MessagePump(true); // peek
	}
	if (m_bWaitIfMinimized) {
		//	WM_QUITŏ̂҂
		while (GetMyWindow()->IsMinimized()){
			if (MessagePump(false)!=0) break; // get
		}
	}

	//	̃`FbN̂ƂɃXbh̐`FbN
	return CThread::IsThreadValid();
}

void	CAppBase::InnerStopThread(){
	if (IsMainApp()) {
		CAppManager::StopAllThread();			//	SXbh~
	} else {
		//	VOXbhȂ΂͌Ăяo܂łȂA~Ă͂
//		StopThread();							//	CXbh̏Iҋ@
	}
	CThread::InvalidateThread();
}

void	CAppBase::InvalidateThread(){	//	overriden from CThread
//	Idle[h̗pĂ̂ŁAbZ[WȂA
//	IsThreadValidĂяoȂAȂ킿AWM_CLOSEɉĕ邱ƂoȂ
	if (m_bIdle){
		HWND hWnd = GetHWnd();
		if (hWnd!=NULL) {	//	̃bZ[WĔj󂵂Ă܂
			//	::SendMessage(hWnd,WM_CLOSE,0,0);
			//	́AbZ[WL[ɐς܂邽߁A
			//	ĂяoXbh̃bZ[W[vĂ΂
			//	܂ŁA̎sxB
			//	āA
			::PostMessage(hWnd,WM_CLOSE,0,0);
			//	ꂪB
		}
	}
	CThread::InvalidateThread();	//	superNXɈϏ
}

IIntervalTimer*	CAppBase::GetIntervalTimer(){ return& m_vIntervalTimer; }

//////////////////////////////////////////////////////////////////////////////
//	̃NX̃bZ[Wp
//		VɃbZ[WƂ́ACWinHookhNXāA
//		ŃtbNĂ˂B
LRESULT CAppBase::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){

	switch (uMsg){

	///////////////////////////////////////////////////////////////////////////
/*
	//	GetMessageŎ̑EBhDbZ[WoĂȂ̂ŁA
	//	Av؂ւƂWM_PAINTEȂƂ悤c(Windows2000̃oO?)
	case WM_ACTIVATEAPP : {
		if( wParam ) UpdateWindow(hWnd);
		break;
						  }
*/
	case WM_CLOSE: { // EChEꂽ
		if (!m_bClose && OnPreClose()) return 1; // ƂɂċA
		CThread::InvalidateThread();
		//	̃NXInvalidateThread́AACh[hWM_CLOSE𔭍ŝŉiv[vɂȂ
//		InnerStopThread();		//	Worker~ĂłȂ
								//	WM_DESTORYhWndɂȂƁA̓r[A
								//	[J[Xbh邱ƂɂȂ
		return 1;
		//	invalidateĂ΁A[J[Xbh͎IɋA҂
		//	A҂[J[XbhWM_DESTROY𔭍sĂ炤
				   }

	case WM_DESTROY:{

		if (IsMainApp()) {
			PostQuitMessage(0); //	CEBhDȂI
		}
		break;
					}
	}
	return 0;
}

void	CAppBase::Close(){
	m_bClose=true;
	::SendMessage(GetHWnd(),WM_CLOSE,0,0);
}

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd