#include "stdafx.h"

#include "yaneFindWindow.h"
#include "../Auxiliary/yaneFile.h"

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

LRESULT CFindWindow::Find(const string& strModuleName) {
	if (InitProcessFunction()!=0) return 1; // s
	m_strModuleName = CFile::GetPureFileNameOf(strModuleName);
	return FindSameWindow();
}

LRESULT		CFindWindow::FindSameWindow( )
{
// EBhE̗񋓗v
	if ( !::EnumWindows( (WNDENUMPROC)CFindWindow::EnumWndProc, (LONG)this ) )
						// ̃LXgȂVC++5ŒʂȂ̂OOGG
		return 0;
	return 1;
}

int	CALLBACK	CFindWindow::EnumWndProc( HWND hWnd, LPARAM lParam ){
	return ((CFindWindow*)lParam) ->InnerEnumWndProc(hWnd);
}

int		CFindWindow::InnerEnumWndProc( HWND hWnd ){

// CX^Xɑ΂t@C̎擾
	CHAR	strFileName[_MAX_PATH];
	if (GetWindowModuleName( hWnd , strFileName, _MAX_PATH )!=0)
		return 1;
	//	WinNTnł́At@CȂB
	//	Win95/98nł́ApX
	//	ꂷ邽߂ɁAł́At@Ĉ݂𒊏orKv

	// t@Cۂ̔
	if ( m_strModuleName == CFile::GetPureFileNameOf(strFileName)) {

		// ȑOɍ쐬EBhEANeBuɂ
		::ShowWindow( hWnd ,SW_SHOWNORMAL);
		::SetForegroundWindow( hWnd );

		return 0;
	}

	return 1;
}

//////////////////////////////////////////////////////////////////////////////
//	vZX̃XibvƂ
//		ȂƁAmȃnhȂ

LRESULT	CFindWindow::InitProcessFunction(void)
{
	HANDLE hKernel;
	hKernel = ::GetModuleHandle("KERNEL32.DLL");

	if ( hKernel ) {
		m_lpCreateToolhelp32Snapshot = (CREATESNAPSHOT)GetProcAddress(
			(HINSTANCE)hKernel, "CreateToolhelp32Snapshot");
		m_lpProcess32First =
			(PROCESSWALK)::GetProcAddress((HINSTANCE)hKernel, "Process32First");
		m_lpProcess32Next =
			(PROCESSWALK)::GetProcAddress((HINSTANCE)hKernel, "Process32Next");
	}
	if ( m_lpProcess32First && m_lpProcess32Next && m_lpCreateToolhelp32Snapshot )
		return 0;
	return 1;
}

LRESULT	CFindWindow::GetWindowModuleName( HWND hWnd , LPTSTR szFileName, DWORD dwSize )
{
	DWORD pid = 0;
	HANDLE hProcessSnap;
	PROCESSENTRY32 pe32;
	LRESULT Ret = 1;

	::GetWindowThreadProcessId(hWnd, &pid);
	hProcessSnap = m_lpCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if ( hProcessSnap == (HANDLE)-1 )
		return 1;
	pe32.dwSize = sizeof(PROCESSENTRY32);
	if ( m_lpProcess32First(hProcessSnap, &pe32) ) {
		do {
			if ( pid == pe32.th32ProcessID ) {
				::lstrcpyn(szFileName, pe32.szExeFile, dwSize);
				Ret = 0;
				break;
			}
		} while ( m_lpProcess32Next(hProcessSnap, &pe32) );
	}
	::CloseHandle(hProcessSnap);
	return Ret;
}

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd
