#include "stdafx.h"
#include "yaneSerialize.h"
#include "yaneStringScanner.h"
#include "yaneFile.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

void	CSerialize::Clear(){
	m_abyData.clear();	//	Xg[̃NA
	m_nDataPos = 0;		//	擪w
	m_bStoring = true;	//	i[
}

//	Ȃł񂩂ȁDD
ISerialize& CSerialize::operator << (IArchive& vData){
	vData.Serialize(*this);
	return *this;
}

//	--- for storing or unstoring primitive data
ISerialize& CSerialize::operator << (BYTE& byData){
	if (IsStoring()){
	//	ۑ񂩂ȁH
		GetData()->push_back(byData);
	} else {
	//	o񂩂ȁH
		byData = (*GetData())[m_nDataPos];
		m_nDataPos++;
	}
	return *this;
}

ISerialize& CSerialize::operator << (int& nData){
	if (IsStoring()){
	//	ۑ񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		int nSize = sizeof(int);
		BYTE* pByte = (BYTE*)&nData;
		for(int i=0;i<nSize;i++){
			GetData()->push_back(pByte[i]);
		}
	} else {
	//	Xg[o񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		int nSize = sizeof(int);
		BYTE* pByte = (BYTE*)&nData;
		for(int i=0;i<nSize;i++){
			pByte[i] = (*GetData())[m_nDataPos++];
		}
	}
	return *this;
}

ISerialize& CSerialize::operator << (bool& bData){
	if (IsStoring()){
	//	ۑ񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		int nSize = sizeof(bool);
		BYTE* pByte = (BYTE*)&bData;
		for(int i=0;i<nSize;i++){
			GetData()->push_back(pByte[i]);
		}
	} else {
	//	Xg[o񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		int nSize = sizeof(bool);
		BYTE* pByte = (BYTE*)&bData;
		for(int i=0;i<nSize;i++){
			pByte[i] = (*GetData())[m_nDataPos++];
		}
	}
	return *this;
}

ISerialize& CSerialize::operator << (string& strData){
	if (IsStoring()){
	//	ۑ񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		BYTE* pByte = (BYTE*)strData.c_str();
		int nSize = strData.size() + 1;
		//	stringɎĂNULL͊܂܂ւ˂..
		//	ꂵAstring̃GgcharƉ肵Ă̂
		//	{͖肪..̂ւunicodeΉ̂ƂɏCׂ

		//	NULL̃oCg܂߂Kv
		for(int i=0;i<nSize;i++){
			GetData()->push_back(pByte[i]);
		}
	} else {
	//	Xg[o񂩂ȁH
		//	TCYsƉ肵R[fBOOOG
		int nSize = ::strlen((LPCSTR)&(*GetData())[m_nDataPos]) + 1;
		strData = (LPCSTR)(&(*GetData())[m_nDataPos]);
		m_nDataPos += nSize;
	}
	return *this;
}

ISerialize& CSerialize::operator << (vector<int>& anData){
	int n;
	if (IsStoring()) {
		n = anData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		anData.resize(n);
	}
	for(int i=0;i<n;i++){
		(*this) << anData[i];
	}
	return *this;
}

ISerialize& CSerialize::operator << (vector<bool>& abData){
	int n;// = abData.size();
// ǉ
	if (IsStoring()) {
		n = abData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		abData.resize(n);
	}
// ǉI
	bool b;
	for(int i=0;i<n;i++){
	//	vector<bool>̎́AoCgf[^ł͂ȂAbit̃pbNł̂ŁA
	//		(*this) << b;̂悤ȂƂ͏oȂB(STLPort)
		if (IsStoring()) {
			b = abData[i];
			(*this) << b;
		} else {
			(*this) << b;
			abData[i] = b;
		}
	}
	return *this;
}

ISerialize& CSerialize::operator << (vector<BYTE>& abyData){
	int n;
	if (IsStoring()) {
		n = abyData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		abyData.resize(n);
	}
	for(int i=0;i<n;i++){
		*this << abyData[i];
	}
	return *this;
}

ISerialize& CSerialize::operator << (vector<string>& astrData){
	int n;
	if (IsStoring()) {
		n = astrData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		astrData.resize(n);
	}
	for(int i=0;i<n;i++){
		*this << astrData[i];
	}
	return *this;
}

// ǉ
ISerialize& CSerialize::operator << (vector<WORD>& awData){
	int n;
	if (IsStoring()) {
		n = awData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		awData.resize(n);
	}
	for(int i=0;i<n;i++){
		*this << awData[i];
	}
	return *this;
}

ISerialize& CSerialize::operator << (vector<DWORD>& adwData){
	int n;
	if (IsStoring()) {
		n = adwData.size();
		(*this) << n;	//	TCYłɕۑȂẮI
	} else {
		(*this) << n;	//	𕜌
		adwData.resize(n);
	}
	for(int i=0;i<n;i++){
		*this << adwData[i];
	}
	return *this;
}
// ǉI

//	gIOOG
ISerialize& CSerialize::operator << (ISerialize& vData){
	//	vector<BYTE>Ȃ̂ŁAȂVACYł
	*this << *vData.GetData();
	*this << *vData.GetStoring(); //m_bStoring;	//	i[
	*this << *vData.GetPos();	//	m_nDataPos;	//	|WV
	return *this;
}

//	āAVACYԂ̃Rs[I
ISerialize& CSerialize::operator = (ISerialize& vSeri){
	//	vector̃Rs[Ȃ̂ŁAstd::vectorɂCOOG
	m_abyData  = *vSeri.GetData();	//	m_abyData;
	m_bStoring = *vSeri.GetStoring(); // m_bStoring;
	m_nDataPos = *vSeri.GetPos(); // m_nDataPos;
//	Rs[ق悤ȋC邪AAA
//	m_bStoring = true;
//	m_nDataPos = 0;
//	ZbgĂ̂DD
	return *this;
}

LRESULT CSerialize::Save(const string& filename){
	//	Xg[̃t@Cւ̕ۑ
	CFile file;
	return file.Save(filename,GetData());
	//	return CFile().Save(...)̂悤
	//	e|IuWFNgŏĂǂA
	//	VC++6.0āAreturn̂ƂłA
	//	oOĂ悤ȋCOOG > T[rXpbNĂĂȂ
}

LRESULT CSerialize::Load(const string& filename){	//	Xg[̃t@C̕
	//	Xg[̃t@C̓ǂݏo
	CFile file;
	return file.Load(filename,GetData());
}

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
