//
//	DirectDrawSurface+DIB wrapper
//


#ifndef __yaneFastPlane_h__
#define __yaneFastPlane_h__


#ifdef USE_FastDraw

#include "yaneSurface.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CFastDraw;

class CFastPlane : public ISurface {
/**
	DirectDrawɂQ@`NXiT[tF[Xj
	class CFastDraw Qlɂ邱ƁB
*/
public:

	///	---- ISurfacẽo
	virtual int GetType() const { return 1; }
	virtual LRESULT Load(const string& strBitmapFileName);
//	virtual LRESULT Save(const string& strBitmapFileName,LPCRECT lpRect=NULL);
//	virtual LRESULT SaveYGA(const string& strBitmapFileName,LPCRECT lpRect=NULL,bool bCompress=true);
	virtual LRESULT	GetSize(int &x,int &y) const;
	virtual LRESULT SetSize(int x,int y){
		int sx,sy;
		GetSize(sx,sy);
		if (sx!=x || sy!=y) return CreateSurface(x,y);
		return 0;	//	resizeƂ
	}
	virtual LRESULT	Release();

	/** ISurfacẽoŏ\Ȃ̂ŁAI[o[Ch͂ĂȂ
	virtual	LRESULT SetColorKey(ISurfaceRGB rgb);
	virtual LRESULT SetColorKeyPos(int x,int y);
	virtual ISurfaceRGB GetColorKey() const;

		vC}^ZJ_̃fBtHg̔FݒɂẮA
		ۏ؊OBvC}ɎẮAT[tF[XlockłȂ
		rfIJ[ĥŁAȂ̂gB
	*/

	/**
	//	defaultŗǂ̂̓I[o[ChĂȂ
	//		fill color...
		virtual void		Clear(LPCRECT lpRect=NULL);
		virtual LRESULT		SetFillColor(ISurfaceRGB c);
		virtual ISurfaceRGB	GetFillColor() const;
	*/

	virtual smart_ptr<ISurface> clone();
	virtual LRESULT CreateSurfaceByType(int sx,int sy,int nType);

	/**
		̑A`֘Ã\bh́AISurfacêق
		Ȃ肠̂ŁAĂB
	*/

	//////////////////////////////////////////////////////////////////////////

	//	eݒ
//	void	SetDirectDrawSurface(bool bEnable);	//	DirectDrawSurfaceɂ̂
	LRESULT	SetSystemMemoryUse(bool bEnable);	//	VXeĝ
	//	́ArύX͕sB
	//	CreateSurafecéALoadBitmapƂLB

	/*
		̂Q̐ݒ́A
			vC}Ftrue  - false
			ZJ_Ffalse - true   or	true  - true
			ʂ̃T[tF[X@@Ffalse - true
		WIƍlB
	*/

	//////////////////////////////////////////////////////////////////////////
	//	HDC𓾂āAڏ:p

	HDC		GetDC();
		//	AȂ炸擾łƂ͌ȂB
		//	K擾Ȃ΂ȂȂ̂ł΁A
		//	SetDirectDrawSurface(true)ɂĂƁB
		//	擾łȂꍇANULLԂ
	void	ReleaseDC();

	///	I[i[h[T[tF[X̐
	///	TCYwŃv[쐬
	///	(sx,sy)TCY  bAlpha==trueȂ΁AT[tF[X
	virtual LRESULT CreateSurface(int sx,int sy,bool bAlpha=false);	

	//	vC}T[tF[X̐
	LRESULT	CreatePrimary(bool& bUseFilp,int nSx=0,int nSy=0);
	//	ZJ_T[tF[X̐
	LRESULT CreateSecondary(CFastPlane*lpPrimary,bool& bUseFlip);

	//////////////////////////////////////////////////////////////////////////
	///		----	Effector

	///@l𔽓]iT[tF[Xɑ΂Ă̂ݗLj
	LRESULT		FlushAlpha(LPCRECT lpRect=NULL) { return 0; } // (todo)

	/////// todo

	//	l𓾂
	virtual int	GetPixelAlpha(int x,int y) { return 0; }
	//	sNZ̐F𓾂

	//////////////////////////////////////////////////////////////////////////
	///	property...

	//	rbg}bvǂݍ܂Ătrue
	bool	IsLoaded() const { return !m_strBitmapFile.empty(); }
	//	ǂݍłrbg}bṽt@CԂ
	string	GetFileName() const;

	//	YGA摜Ȃ̂ǂ
	virtual	bool	IsYGA() { return m_bYGA; }
	bool*	GetYGA() { return& m_bYGA; }

	void	SetYGAUse(bool bUse) { m_bYGAUse = bUse; }
	bool	GetYGAUse() { return m_bYGAUse; }
	//	trueݒ肷΁LoadƂACreateSurfaceƂA
	//	IɏɃtT[tF[X쐬B
	//	fBtHgłfalse

	//	CT[tF[Xɂ(default:false)
	//		(ꂾLostȂBA32bpp->16bpp̂悤ȕϊɂărbg[x)
	void	SetAutoRestore(bool bEnable) { m_bAutoRestore = bEnable; }
	bool	GetAutoRestore() { return m_bAutoRestore; }

	LPDIRECTDRAWSURFACE GetSurface();
	LPDIRECTDRAWPALETTE GetPalette();
	//	DirectDrawSurfaceƂ͌Ȃ̂ŁÂQ
	//		擾ł邩ǂ킩ȂDD
	//		擾łȂƂ́ANULLԂ

	int		GetBpp() const {
		const int anType[] = { 0,0,8,16,16,24,24,32,32,0,16,16,32,32 };
		return anType[const_cast<CFastPlane*>(this)->GetSurfaceType()];
	}

	//	0`1(s)̏ꍇADIB(16bpp)ɂ܂B
	//	ȊȌꍇAm_bMemorySurfacetrueł΁AT[tF[X
	//	Ȃ΁ADirectDrawSurfacełAm_lpSurfaceLƂƂ
	//	Ȃ܂B

	//	s̏ꍇAZJ_Ƃ́Ał
	//	vC}֓]ĂKv̂ŁA
	//	DIBSectionׂH
	//	ƂAsĂǂƁHH

	//////////////////////////////////////////////////////////////////////////

	///		FastDrawmediator
	void	SetFastDraw(CFastDraw*p) { m_pFastDraw = p; }
	CFastDraw* GetFastDraw() const { return m_pFastDraw; }

	/**		fBtHgŎgpFastDraw̐ݒ/擾
		́A
		1.CFastPlane::SetFastDraw@
		2.CFastPlanẽRXgN^
		CFastDraw*nĂȂƂɌgpfBtHg
		CFastDraw̐ݒ^擾B

		@ThreadLocalŕێĂ܂B

		CFastDraw̃RXgN^SetDefaultFastDraw(this);ƂĂ̂ŁA
		1XbhCFastDrawЂƂ݂Ȃꍇ͓ɉȂok

	*/
	static void	SetDefaultFastDraw(CFastDraw*p) { m_pDefaultFastDraw = p; }
	static CFastDraw* GetDefaultFastDraw() {
		return m_pDefaultFastDraw.isEmpty()?NULL:*m_pDefaultFastDraw.Get();
	}

	///	vC}T[tF[XlockłȂƂ̂œꈵ
	bool	IsPrimarySurface () const { return m_bPrimary; }

	//////////////////////////////////////////////////////////////////////////

	CFastPlane(CFastDraw* pFastDraw=NULL);
	virtual ~CFastPlane();

	friend class CFastDraw;

protected:

	LPDIRECTDRAWSURFACE m_lpSurface;
	//	DirectDrawSurfacêƂ́Ã|C^
	LPDIRECTDRAWPALETTE m_lpPalette;
	//	DirectDrawPalettêƂ́Ã|C^

	//	CreateDIBSectionōT[tF[X̏ꍇ
	//	(ssNZtH[}bgɑ΂ăZJ_̂݁AŗL蓾)
	HBITMAP m_hBitmap;
	HDC		m_hDC;

	//	256F[h̎ɓǂݍ񂾉摜́ÂƂHDCɈˑ̂
	//	RGB555ɕύXꂽƂ́AǂݒKv
	bool	m_bLoad256;

	//	ĈŁAQƃJE^͗pӂȂB

	//	v[̃TCY
	int		m_nSizeX;
	int		m_nSizeY;

	//	bitmapt@C
	string	m_strBitmapFile;				// t@CۑƂȂ
		//	rbg}bvǂݍłȂƂ́At@C͋ł

	//////////////////////////////////////////////////////////////////////////
	//	T[tF[X̕A
	//	XgA͓IɌĂяoi[U[͒ʏAڌĂяoƂ͖j
	virtual LRESULT	Restore();
	//	XgAɂ́Å֐I[o[ChiʏA̕Kv͖j

	virtual LRESULT OnDraw(){ return 0; }
	//	v[̂̕߂ꂪĂяoiI[o[Chj

	virtual LRESULT	InnerLoad(const string& strFileName);
	virtual LRESULT InnerCreateSurface(int sx,int sy,bool bYGA=false,bool bSecondary256=false);

	//	TCYwŃv[쐬
	LRESULT InnerCreateMySurface(int sx,int sy,int nSurfaceType,bool bClear=true);
	/**
		bClear == trueȂ΁Aʂ(Clear)@false
		AɃT[tF[XɃf[^ǂݍނƂ
		킩Ă̂Ȃ΃NAKv͖
	*/

	LRESULT InnerRestoreSurface();		//	T[tF[X̃XgAipj
	LRESULT	UpdateSurfaceInfo();		//	T[tF[XXVipj
	//	ĂяoGetSurface()słȂƂۏ؂ׂ

	//////////////////////////////////////////////////////////////////////////


	bool	m_bUseSystemMemory;			//	IɃVXegIvV
//	bool	m_bUseDirectDrawSurface;	//	IDirectDrawSurfacegIvV

	ISurfaceRGB m_FillColor;			//	`NAF
	DWORD	m_dwFillColor;				//	̐F݂̃T[tF[Xɕϊ

	//////////////////////////////////////////////////////////////////////////

	//	T[tF[X
	bool	m_bYGA;					//	YGA摜ł邩
	bool	m_bYGAUse;				//	IɃtT[tF[X쐬
	bool	m_bAutoRestore;			//	XgÂ
	bool	m_bMySurface;			//	newSurfaceH
	bool	m_bSecondary256;		//	256Fp̃ZJ_
									//	ĩT[tF[X256F[hłRGB555ł͂Ȃ256Fj
	bool	m_bSecondary256DIB;		//	256Fp̃ZJ_
									//	ĩT[tF[X́ARGB555DIBSectionj
	bool	m_bOwnerDraw;
	//	I[i[h[(ɂĂRestoreĂяoȂBPrimary,Secondary͂)
	bool	m_bPrimary;				//	vC}T[tF[X(lockoȂƂ̂œ)

	//////////////////////////////////////////////////////////////////////////

	//	Sv[ւ̃CX^X̃`FC
	//	̃`FCɂPrimary,Secondary܂ނ̂ŒӂKv
//	static set<CFastPlane*>	m_lpPlaneList;

	//	YGA摜̓ǂݍݗp
	LRESULT InnerLoadYGA(const string& strFilename);

protected:
//	static DWORD DDColorMatch(LPDIRECTDRAWSURFACE pdds, COLORREF rgb); // FT
//	static DWORD DDGetPixel(LPDIRECTDRAWSURFACE pdds,int x,int y); // ̓_̐F𒲂ׂ
	//	̃T[tF[XDirectDrawSurfaceƂ͌Ȃ̂ŁAł͎ĝɂȂȂIR(`DL)m

//	static void	InnerGetBpp();	//	bpp manager̃Zbg
//	static int	GetBpp();		//	bpp̎擾

	CFastDraw*	m_pFastDraw;
	static ThreadLocal<CFastDraw*>	m_pDefaultFastDraw;

	// FastDraẃASetFastDrawŐݒ肳ꂽ̂ԂBݒ肳ĂȂ΃fBtHĝ̂Ԃ
	CFastDraw* GetMyFastDraw() const {
		if (m_pFastDraw!=NULL) return m_pFastDraw;
		return GetDefaultFastDraw();
	}

	bool m_bNowRestoring;	//	XgÃtO
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif	// USE_FastDraw

#endif	// ifdef __yaneFastDraw_h__

