#include "stdafx.h"
#include "yaneScene.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

void	CSceneControl::CreateScene(int nScene){

	if (nScene==-1) return ; // ꎸsȂ
	//	VV[\z
	CSceneInfo* pInfo = new CSceneInfo;
	pInfo->m_lpScene = GetSceneFactory()->CreateScene(nScene);
	pInfo->m_nScene = nScene;
	if (!pInfo->m_lpScene.isNull()){
		pInfo->m_lpScene->SetSceneControl(smart_ptr<ISceneControl>(this,false));
		pInfo->m_lpScene->OnInit();	//	ŏB
	}
	//	X^bNɒǉ
	GetSceneStack()->push_back(smart_ptr<CSceneInfo>(pInfo));
}

void	CSceneControl::OnMove(const smart_ptr<ISurface>& lpDrawContext) {// ǉ
	//	OnInit̂ȂŎXƃV[Wv̂ŐɃbZ[WNA
	do {
	//	Cfg̖ʓ|Ȃ̂łŁOOG

	int nMessage = m_nMessage;
	m_nMessage = 0;

	//	bZ[Wdispatch
	switch (nMessage) {
		//	0:No Message 1:JumpScene 2:CallScene
		//	3:CallSceneFast 4:ReturnScene 5:ExitScene
	case 0: break;
	case 1:
		//	݂̃V[Ȃ΁Aj
		if (!IsEnd()){
			GetSceneStack()->pop_back();
		}
		//	VV[\z
		CreateScene(m_nNextScene);
		break;
	case 2: {
		//	݂̃V[j
		if (!IsEnd()){
			(*GetSceneStack()->rbegin())->m_lpScene.Delete();
		}
		//	VV[\z
		CreateScene(m_nNextScene);
		break;
			}
	case 3:
		//	݂̃V[X^bNɐςŁADeleteȂB
		//	˃X}[g|C^ɂȂĂ̂pushĂDeleteȂB
		//	VV[\z
		CreateScene(m_nNextScene);
		break;
	case 4:	{		//	̃V[ɖ߂B
		//	݂̃V[j
		if (IsEnd()){
#ifdef USE_EXCEPTION
			throw CSyntaxException("ȏReturnSceneoȂ");
#endif
		} else {
			GetSceneStack()->pop_back();
		}
		if (IsEnd()) break; //	߂V[˂

		CSceneInfo& pInfo = **GetSceneStack()->rbegin();
		int nScene = pInfo.m_nScene;
		if (pInfo.m_lpScene.isNull()) {
			//	V[Ă邩AfactoryŁA܂ɂI
			GetSceneStack()->pop_back();
			CreateScene(nScene);
			//	ꉞAĂяoOOG
			if (!(*GetSceneStack()->rbegin())->m_lpScene.isNull()) {
				(*GetSceneStack()->rbegin())->m_lpScene->OnComeBack(nScene);
			}
		} else {
			//	AĂŁ`@WF[Jo[NbOOG
			(*GetSceneStack()->rbegin())->m_lpScene->OnComeBack(nScene);
		}
		break;
			}
	case 5:	return ;	//	`悹ɔ
	}

	if (!IsEnd() && !(*GetSceneStack()->rbegin())->m_lpScene.isNull()) {
		(*GetSceneStack()->rbegin())->m_lpScene->OnMove(lpDrawContext);
	}

	//	Cfg̖ʓ|Ȃ̂łŁOOG
	} while (m_nMessage!=0);
	//	LOnDraŵȂłɎ̃V[ɔԂƂB
	//	bZ[W͖Ȃ܂ŏ̂

	return ;
}

void CSceneControl::OnDraw(const smart_ptr<ISurface>&lpDrawContext) {// ǉ
	if (!IsEnd() && !(*GetSceneStack()->rbegin())->m_lpScene.isNull()) {
		(*GetSceneStack()->rbegin())->m_lpScene->OnDraw(lpDrawContext);
	}
	return ;
}

void	CSceneControl::PushScene(int nScene){
	//	w肳ꂽV[X^bNɐςށB
	CSceneInfo* pInfo = new CSceneInfo;
	pInfo->m_nScene = nScene;
	GetSceneStack()->push_back(smart_ptr<CSceneInfo>(pInfo));
}

bool	CSceneControl::IsEnd() const{
	return const_cast<CSceneControl*>(this)->GetSceneStack()->size()==0;
}

int CSceneControl::GetSceneNo() const{
	if (IsEnd()) return -1;
	return (*(const_cast<CSceneControl*>(this))->GetSceneStack()->rbegin())->m_nScene;
}

smart_ptr<IScene> CSceneControl::GetScene() const{
	if (IsEnd()) return smart_ptr<IScene>();
	return (*(const_cast<CSceneControl*>(this))->GetSceneStack()->rbegin())->m_lpScene;
}

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd
