//
//	Mersenne Twister@ɂ鍂x
//	@2^19937-1ƂɒɐI
//

#ifndef __yaneRand_h__
#define __yaneRand_h__


#include "../Auxiliary/yaneSerialize.h"

namespace yaneuraoGameSDK3rd {
namespace Math {

class CRand : public IArchive { // ̃NX́AVACYΉI
/**
	Mersenne Twister@ɂ鍂x̗[`łB
	2^19937-1ƂVwIȑ傫̎ɐ܂B

	class IArchive hNXȂ̂ŁACӂ̃^C~Oŗ̎
	̂܂ܕۑĂAn̗ēx邱Ƃo܂B
*/
public:
	///	̎擾BO҂DWORDS̗擾B
	///	҂́A0`n-1܂ł̗擾B
	///	n==0̏ꍇ0Ԃ(̂قg₷̂)
	DWORD	Get();					//	̎擾
	DWORD	Get(DWORD n) {			//	0`n-1̗̎擾
		if (n==0) { 
/**
#ifdef USE_EXCEPTION
			throw	CRuntimeException();
#else
			return n;
#endif
*/
			return 0;
		}
		return Get() % n;
	}

	void	SetSeed(DWORD dwSeed);
	/**
		̎ݒ肵܂Bݒ肳ꂽɏ]āA͐Ă܂B
		Kx͌ĂяoKv܂B
		ĂяoȂƂ́A
			SetSeed(4357);
		Aԍŏ̗擾̂ƂɎs܂B
	*/

	void	Randomize()
	/**
		̎ƂāAݎ^܂B
		vɁAČ̖o܂B
		SetSeed(GetTickCount())ƂĂ̂ŁA
		SetSeedĂяoKv͂܂B
	*/
		{	SetSeed(::GetTickCount());	}

	CRand() { m_nMti = 624+1; } /* means m_dwMt is not initialized */
	CRand(DWORD dwSeed) { SetSeed(dwSeed); }
	/**
		RXgN^́AQނAp[^̂ق́A
		̏sȂ܂Bp[^L̂ق́A
		̎ƂĎAɊÂ𐶐܂B
		iISetSeedsȂƂƂłB
		āASetSeed̂ƍsȂKv͂܂j
		OƓnČꍇȂǂɂg܂B
	*/

	virtual ~CRand() {}

protected:
	DWORD	m_dwMt[624];	// the array for the state vector
	int		m_nMti;			// initialization counter

protected:
	//	override from IArchive
	virtual void Serialize(ISerialize& s){
		s.Store(ArraySerialize(m_dwMt));	//	oϐ܂邲ƁA
		s << m_nMti;						//	VACŶI
	}
};

} // end of namespace Math
} // end of namespace yaneuraoGameSDK3rd

#endif
