// enraACMStream.h
//		programmed by ENRA		'02/03/25

#ifndef __yaneACMStream_h__
#define __yaneACMStream_h__


#include "yaneSoundStream.h"
#include <msacm.h>

namespace yaneuraoGameSDK3rd { namespace Auxiliary { class IFile; }}

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class CACMStream : public ISoundStream {
/**
	ACM𗘗păTEhf[^ǂݍ class ISoundStream hNX
	kt@CHDD璀ǂݏôł͂ȂACɓǂݍށB
*/
public:
	CACMStream();
	virtual ~CACMStream();

	/// override from class ISoundStream
	LRESULT	Open(const char* filename);
	LRESULT	Close();
	LONG	GetLength() const;
	LRESULT	SetCurrentPos(LONG lPosition);
	LONG	GetCurrentPos() const;
	DWORD	Read(BYTE* lpDest, DWORD dwSize);
	WAVEFORMATEX* GetFormat() const { return m_pDestFormat; }

protected:
	LRESULT InnerRead(BYTE* lpDest, DWORD dwSize, DWORD& dwReaded);

	// t@CpIFile𓾂
	smart_ptr<IFile>	GetFile() const { return m_vFile; }
	smart_ptr<IFile>	m_vFile;

	// Openp̃wp֐
	// mmioOpenAWAVEFORMATEX̐ݒAf[^TCY̎擾Ȃǂs
	LRESULT	InitializeNormal();
	// MP3t@C𒼐ڃI[v
	LRESULT	InitializeMP3();

	// Pʕϊpwp֐i0xffffffff̓G[j
	LONG	ByteToMsec(DWORD dwByte) const;
	DWORD	MsecToByte(LONG lMsec) const;

	// HMMIO
	HMMIO	m_hmmio;
	// WAVEFORMATEX
	WAVEFORMATEX*		 m_pSrcFormat;
	WAVEFORMATEX*		 m_pDestFormat;		// const֐łԂ悤
	WAVEFORMATEX		 m_vDestFormat;		// ̎̂͂^^;
	MPEGLAYER3WAVEFORMAT m_vMP3Format;		// mp3̃wb_[pӂ
	// HACMSTREAM
	HACMSTREAM		 m_hAcm;
	// ACMSTREAMHEADER
	ACMSTREAMHEADER	 m_vAcmHeader;

	// ϊf[^̑S(byte)
	DWORD	m_dwSrcLength;
	// ϊf[^ւ̃t@C擪̃ItZbg
	DWORD	m_dwDataOffset;
	// ϊf[^̈ʒu
	DWORD	m_dwReadPosition;

	// ϊf[^̑S(msec)
	DWORD	m_lDestLength;
	// ܂łɏ񂾃TCY
	DWORD	m_dwDestTotalWritten;

	// ACM̓ubNZobt@󂯕tȂ
	DWORD m_dwSrcBlockLength;
	DWORD m_dwDstBlockLength;
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneACMStream_h__
