// DirectMusic Wrapper

#include "stdafx.h"
#include "../Auxiliary/yaneCOMBase.h"
#include "../AppFrame/yaneAppManager.h"
#include "../Multimedia/yaneDirectSound.h"
#include "../Multimedia/yaneDirectMusic.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

///////////////////////////////////////////////////////////////////////////

bool CDirectMusic::CanUseDirectMusic(){
	//	DirectMusicgȂ̂ǂ𒲂ׂĕԂ
	static bool bFirst = true;
	static bool bUse   = false;

	if (bFirst){	//	ŏ̂P̂ݒׂĕԂ
		bFirst = false;
		CCOMObject<IDirectMusicPerformance*> obj;
		bUse = obj.CreateInstance(
			CLSID_DirectMusicPerformance,IID_IDirectMusicPerformance)==0;
	}
	return bUse;
}

///////////////////////////////////////////////////////////////////////////

CDirectMusic::CDirectMusic(CDirectSound* p/*=NULL*/) :
	m_nStatus(0),m_lpDMusic(0)
{
	if (GetDirectMusicPerformance()->CreateInstance(
		CLSID_DirectMusicPerformance,IID_IDirectMusicPerformance)!=0){

		m_nStatus = 1;
		return ;
	}

	// DirectSoundAttach݂
	if (p&&p->Get()){
		m_pDirectSound = p->Get();
	}

	//	DirectSound珉
	//	m_lpDMusic = NULL;	//	ĂȂbugB
		//	Ԃl̂߂ɓnϐ̏v邾ȂāA
		//	ƂłȂ>DirectMusic
	if (FAILED(GetDirectMusicPerformance()->get()->
			Init(&m_lpDMusic,GetDirectSound(),NULL))){
		m_nStatus = 2;
		m_lpDMusic = NULL;	//	NULLۏ؂
		return ;
	}

	//	A|[giVZTCUj̑I͍sȂ
	if (FAILED(GetDirectMusicPerformance()->get()->AddPort(NULL))){
	//	m_lpDMusic󂯂Ăꍇ́A
	//	|[głȂ΂ȂȂ
			//	T[hp[eB̃\tgVZ̓fBtHg
			//	I邱Ƃ͖̂ł̏ꍇAs
			//	ǃh}Ci΁j
	}

	if (GetDirectMusicLoader()->CreateInstance(
		CLSID_DirectMusicLoader,IID_IDirectMusicLoader)!=0){
		m_nStatus = 3;
	}

	//	ĐsȂ̂ŃZOg̃LbVݒ؂
	//	؂ĂoO悤OOG
	GetDirectMusicLoader()->get()->EnableCache(GUID_DirectMusicAllTypes,false);
	GetDirectMusicLoader()->get()->EnableCache(CLSID_DirectMusicSegment,false);
}

CDirectMusic::~CDirectMusic(){
	GetDirectMusicLoader()->Release();	//	Loaderɉ̂Ȃ΂ȂȂ

	if (GetDirectMusicPerformance()!=NULL){
		GetDirectMusicPerformance()->get()->CloseDown();
		GetDirectMusicPerformance()->Release();
	}
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
