// DirectSound Wrapper

	//@TEhhCo[𕡐T|[gKv̂Ȃ΁A
	//	TEh݂̊֐́AׂĊ֐|C^ƂĈׂ
	//	AKɂāADirectSound邩ȂȂ̂ŁA
	//	܂łȂB

#include "stdafx.h"
#include "yaneDirectSound.h"
#include "../Auxiliary/yaneCOMBase.h"		//	COM̗p̂
#include "../AppFrame/yaneAppManager.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

//////////////////////////////////////////////////////////////////////////////

// static member
bool CDirectSound::CanUseDirectSound(){
	//	DirectMusicgȂ̂ǂ𒲂ׂĕԂ
	static bool bFirst = true;
	static bool bUse   = false;

	if ( bFirst ) {	//	ŏ̂P̂ݒׂĕԂ
		bFirst = false;
		CCOMObject<LPDIRECTSOUND> obj;
		bUse = obj.CreateInstance(CLSID_DirectSound, IID_IDirectSound)==0;
	}
	return bUse;
}

//////////////////////////////////////////////////////////////////////////////

CDirectSound::CDirectSound()
{
	m_nStatus = 0;
	m_hWnd = CAppManager::GetHWnd();

	// Create the DirectSound object
	if ( GetObject()->CreateInstance(CLSID_DirectSound, IID_IDirectSound)!=0 ) {
		Err.Out("CDirectSound::CDirectSound() object̍쐬Ɏs");
		// SoundCARD݂Ȃꍇ́ÃG[
		m_nStatus = 1;
		return ;
	}

	// ̑Pp[^̓TEhJ[hGUID
	if ( Get()&&Get()->Initialize(NULL)==DS_OK ) {
	} else {
		Err.Out("CDirectSound::CDirectSound() InitializeɎs");
		// COMIuWFNĝ
		GetObject()->Release();
		m_nStatus = 2;
		return ;
	}

	// Set the cooperation level for the DirectSound object
	if ( SetCooperativeLevel(DSSCL_NORMAL)!=DS_OK ) {
		Err.Out("CDirectSound::CDirectSound() SetCooperativeLevel̎s");
		// COMIuWFNĝ
		GetObject()->Release();
		m_nStatus = 3;
		return ;
	}
}

CDirectSound::~CDirectSound(){
	// Ô߁AƂ̋xɖ߂
	SetCooperativeLevel(DSSCL_NORMAL);
}

//////////////////////////////////////////////////////////////////////////////
LRESULT CDirectSound::SetCooperativeLevel(DWORD dwLevel)
{
	// ɎsĂG[
	if ( m_nStatus!=0 ) {
		Err.Out("CDirectSound::SetCooperativeLevel(%d) DirectSound̏ɎsĂ", dwLevel);
		return 1;
	}

	if ( Get()->SetCooperativeLevel(m_hWnd, dwLevel)!=DS_OK ) {
		Err.Out("CDirectSound::SetCooperativeLevel(%d) SetCooperativeLevel̎s", dwLevel);
		return 2;
	}
	
	return 0;
}

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd
