#include "stdafx.h"
#include "yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

CCriticalSection::CCriticalSection(){
	::InitializeCriticalSection(&m_csCriticalSection);
	m_dwLockedThread = (DWORD)-1;
	m_nLockCount	= 0;
}

CCriticalSection::~CCriticalSection(){
	::DeleteCriticalSection(&m_csCriticalSection);
	if (m_nLockCount!=0) {
#ifdef USE_EXCEPTION
		throw CRuntimeException("CCriticalSectionEnter񐔂LeaveȂ܂܏IĂ");
#endif
	}
}

void CCriticalSection::Enter(){
	::EnterCriticalSection(&m_csCriticalSection);
	m_dwLockedThread = ::GetCurrentThreadId();
	//	قȂXbh炱ɓĂ邱Ƃ͂łȂ
	//	(CriticalSection̒`)
	m_nLockCount++;
}

void CCriticalSection::Leave(){
#ifdef USE_EXCEPTION
	if (m_nLockCount==0){
		throw CRuntimeException("CCriticalSectionEnterĂȂ̂LeaveĂ");
	}
#endif
	if (--m_nLockCount==0) {
		m_dwLockedThread = (DWORD)-1;
	}
	//	LeaveɑXbhEnter\
	::LeaveCriticalSection(&m_csCriticalSection);
}

bool CCriticalSection::IsLockedByThisThread() const{
	DWORD dw = ::GetCurrentThreadId();
	return m_dwLockedThread == dw;
}

/////////////////////////////////////////////////////////////////////

CCriticalLock::CCriticalLock(ICriticalSection* cs): m_cs(cs),m_nLockCount(0)
{
	Enter();
}

void	CCriticalLock::Leave(){
	if (m_nLockCount-- == 0){
/*
#ifdef USE_EXCEPTION
		throw CRuntimeException("CCriticalLock::Leave(EnterĂȂ)");
#endif
*/
		//	͎͂肤
		//	)CriticalLockĂȂŁALeaveāÂ
		//		OEnterȂOɔȂ..
		return ;
	}
	m_cs->Leave();
}

void	CCriticalLock::Enter(){
	m_cs->Enter();
	m_nLockCount++;
	//	 if (++m_nLockCount==0) { m_cs->Enter(); }
	//	Ƃ͏ȂBȂȂA++m_nLockCountatomicł͖
}

CCriticalLock::~CCriticalLock()
{
	//	guardĂƂ̂݉
	if (0<m_nLockCount){
		for(int i=0;i<m_nLockCount;i++) m_cs->Leave();
	}
}

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd
