#include "stdafx.h"
#include "yaneLockObject.h"

#include "../Thread/yaneThread.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

LRESULT	CLockObject::wait(int nTimeOut/*=-1*/)
{
	//	waitƂ̓L[ɕԂׂ

	//	LocklĂȂȂ΁AOX[
#ifdef USE_EXCEPTION
	if (!GetCriticalSection()->IsLockedByThisThread()){
		throw CIllegalMonitorStateException();
	}
#endif

	//	ŎsɁthrowɂG[oA
	//	synchronizedɂwaitĂ(G[)ƂƂ

	CWaitState* pWaitState = new CWaitState;
	GetWaitThreadList()->push_back(smart_ptr<CWaitState>(pWaitState));

	DWORD dwThreadId = ::GetCurrentThreadId();
	pWaitState->SetThreadId(dwThreadId);

//	pWaitState->GetEvent()->GetCriticalSection()->Enter();
	GetCriticalSection()->Leave();
		//	Lock

	/*
		LRESULT lr = pWaitState->GetEvent()->Wait(nTimeOut);
		//	VOiԂɂȂ̂҂(łɂȂĂĂ)
	*/

	//	Xbh̗OCxgƁAL̃Cxg̗ĎKv

	IThread* pThread = IThread::getThread();
	LRESULT lr;
	if (pThread!=NULL){
		const HANDLE h[] = {
			//	OCxgƐCxgƂ̗ĎKv
			pThread->GetExceptionEvent()->GetHandle(),
			pWaitState->GetEvent()->GetHandle()
		};
		DWORD dwResult = ::WaitForMultipleObjects(2,&h[0],FALSE,nTimeOut);
		lr = dwResult == WAIT_TIMEOUT ? 1:0;
	} else {
		lr = pWaitState->GetEvent()->Wait(nTimeOut);
	}

	GetCriticalSection()->Enter();
		//	ēxlockl

	eraseThreadInWaitList(dwThreadId);
	//	҂ĂXbhXg炱̃Xbh̏

	#ifdef USE_EXCEPTION
	//	A荞ݏԂɂȂĂAOX[
	if (pThread!=NULL && pThread->interrupted()){
			throw CInterruptedException();
	}
	#endif

	return lr;
}

void	CLockObject::notify(){
	/// waitő҂ĂXbh@N(1̂)
//	CCriticalLock cl(GetCriticalSection());
	//	LocklĂȂȂ΁AOX[
#ifdef USE_EXCEPTION
	if (!GetCriticalSection()->IsLockedByThisThread()){
		throw CIllegalMonitorStateException();
	}
#endif

	if (GetWaitThreadList()->empty()) return ;
	(*GetWaitThreadList()->rbegin())->GetEvent()->SetEvent();
}

void	CLockObject::notifyAll() {
	/// waitő҂Ă邷ׂẴXbh@N
	//	LocklĂȂȂ΁AOX[
#ifdef USE_EXCEPTION
	if (!GetCriticalSection()->IsLockedByThisThread()){
		throw CIllegalMonitorStateException();
	}
#endif
//	CCriticalLock cl(GetCriticalSection());
		
	smart_vector_ptr<CWaitState>::iterator it =
		GetWaitThreadList()->begin();
	while (it!=GetWaitThreadList()->end()){
		(*it)->GetEvent()->SetEvent();
		it++;
	}
}

void	CLockObject::eraseThreadInWaitList(DWORD dwThreadId){

	//	LocklĂȂȂ΁AOX[
#ifdef USE_EXCEPTION
	if (!GetCriticalSection()->IsLockedByThisThread()){
		throw CIllegalMonitorStateException();
	}
#endif

	smart_vector_ptr<CWaitState>::iterator it =
		GetWaitThreadList()->begin();
	while (it!=GetWaitThreadList()->end()){
		if ((*it)->GetThreadId() == dwThreadId){
			it = GetWaitThreadList()->erase(it);
		} else {
			it++;
		}
	}
}

void	CLockObject::notifyThreadInWaitList(DWORD dwThreadId){

	//	LocklĂȂȂ΁AOX[
#ifdef USE_EXCEPTION
	if (!GetCriticalSection()->IsLockedByThisThread()){
		throw CIllegalMonitorStateException();
	}
#endif

	smart_vector_ptr<CWaitState>::iterator it =
		GetWaitThreadList()->begin();
	while (it!=GetWaitThreadList()->end()){
		if ((*it)->GetThreadId() == dwThreadId){
			(*it)->GetEvent()->SetEvent();
			//	ʒm̂I
		}
		it++;
	}
}

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd
