
#ifndef __yaneMicroThread_h__
#define __yaneMicroThread_h__


#include "../Auxiliary/yaneAllocator.h"
#include "../Thread/yaneThread.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

//#define __BORLANDC__
	//	VCBCB5Œʂ邩fobOƂ̃V{`

#ifdef USE_EXCEPTION
//	OLłȂ΁ÃNX̖ɂ

class CMicroThread {
/**
	̃NXʂČĂяo֐́A֐̓rresumeA
	ɌĂяoꂽƂɁAȑȌԂČ邱Ƃo

	vO

	struct CCharacter {
		void	OnMove(){
			if (!microthread_.isEnd()){
				if (!microthread_.isSuspended()) {
					smart_ptr<function_callback> fn(function_callback_v::Create(&CCharacter::MicroThread));
					microthread_.start(fn);
				} else {
					microthread_.resume();
				}
			}
		}
		void MicroThread(){
			int i,x=100,y=200;
			for(i=0;i<100;++i) { x+=2; suspend(); }
			for(i=0;i<100;++i) { y+=2; suspend(); }
		}
	protected:
		void suspend() { microthread_.suspend(); }
		CMicroThread microthread_;
	};

	̂悤ɂ΁AOnMoveĂяoƂɁA
	x+=2100OnMoveĂяoԁAJԂ
	101ڂOnMověĂяóAy+=2sB
	100JԂă}CNXbh͏I܂B
	(ȍ~AOnMoveĂяoĂN܂)

	ӁFO邽߂ɂ́A}CNXbh̃X^bN
		OS̊ǗX^bN̈ɂȂ΂ȂȂB
		(Win32\O̐)
		ŁAX^bN̈Ƀ}CNXbh̃X^bNmۂ
		KvB

		̂߂ɂ́ˁ@class CMemoryAllocatorPool
		@pƗǂB
		)
			const int stack_size = 1024*128; // 128k
			BYTE local_stack[stack_size]; // 128k
			CMemoryAllocatorPool pool;
			pool.SetMemory(&local_stack[0],stack_size);

			X^bN̈ɊmۂꂽzA
			CMemoryAllocatorPoolɐH킹āA
			CMicroThread̃RXgN^œnB

		΁ACMicroThread̃fXgN^ŁAsuspend
		}CNXbhCMicroThreadQuitExceptionO𔭐A
		Jnn_܂ŃX^bN̊߂(fXgN^̌Ăяo)
		sȂƂۏ؂łB

		܂A}CNXbhsuspendɏIꍇłA
		OɂĐɃX^bN̊߂N邱Ƃۏ؂B

		āÃNX𗘗pɂ͗OLłȂ΂ȂȂI

*/
public:

	void	start(const smart_ptr<function_callback>& fn,int nStackSize=0x8000);
	/**
		}CNXbh̎sJnB
		X^bNTCY̓fBtHg0x8000oCgB
		ĂȂԂsuspendƂresumeƂĂяoĂ͂ȂB

		Ȋ֐ł0x2000ȏ͕KvB
		debugrhƏ璷ȃR[hɂȂ̂ŁAǂĂ..
		idebugrhreleaserhŃTCY؂ւĂǂj
	*/

	void	suspend();		///	s̏𒆒f
	void	sleep(int n);	/// s̏n񒆒fBsuspendnĂяoƍlΗǂ
	void	resume();		///	fĊJ

	///	TXyhH
	bool	isSuspended() const { return bSuspended_;}

	///	}CNXbh̎s͏IH
	bool	isEnd() const { return bEnd_; }

	/**
		݃}CNXbhgpĂX^bNTCYԂ
		(}CNXbhłAOłĂяoƂo)
		}CNXbhĂяoāAǂꂭ炢̃HĂ̂
		`FbNĂƂ߂܂B(DebugrhReleaserhƂ
		炭Ⴄ̂ŒӂKv)
	*/
	int		GetUseStackSize() const;

	void	SetMemoryAllocator(IMemoryAllocator*pAllocator) {
		pAllocator_=pAllocator;
	}
	///	RXgN^Őݒ肵тꂽAP[^Ƃݒ肷邽߂̊֐

	static void	SetDefaultMemoryAllocator(IMemoryAllocator*pAllocator) {
		pDefaultAllocator_=pAllocator;
	}
	static IMemoryAllocator* GetDefaultMemoryAllocator(){
		return pDefaultAllocator_;
	}

	CMicroThread(IMemoryAllocator*pAllocator=NULL)
		:bSuspended_(false),bEnd_(false)
		,pAllocator_(pAllocator),abyStack_(NULL) {}

	virtual ~CMicroThread();

protected:
	BYTE*		abyStack_;	//	X^bN
	int			anStackSize_;
	void		ReleaseStack();

	smart_ptr<function_callback> fn_; // R[obNfunction

	bool			bSuspended_;	//	}CNXbh̃TXyh
	bool			bEnd_;			//	}CNXbh̏ItO
	BYTE*			register_esp_;			//	L^Ăesp
	IMemoryAllocator* pAllocator_;

	static void	QuitFunction();		//	AZuĂяoO𔭐֐

//		BCBł́Ainline֐_asmgȂ̂(;LD`)
#if defined(yaneSDK_BCC_Mode)||defined(yaneSDK_CodeWarrior_Mode)
	void	SwitchThread();
#else
	#ifdef yaneSDK_MSVC_Mode
	#pragma warning(disable:4731)	//	ebpύX炢ŶȂ(߄t)٧
	#pragma warning(disable:4733)	//	fs:[0]ύX炢ŶȂ(߄t)٧
	#endif
	void	SwitchThread(){
		_asm {
			//	݂̉zX^bNɐς
			push	offset Next
			//	resumêƂɖ߂ĂKv̂

			push	ebx
			push	ebp
			push	esi
			push	edi

			push	dword ptr fs:[0]	//	Ô߂ɕKv

			mov		eax,[this]
			xchg	esp,[eax].register_esp_

			pop		dword ptr fs:[0]	//	Ô߂ɕKv

			pop		edi
			pop		esi
			pop		ebp
			pop		ebx

//			pop		eax
//			jmp		eax
			ret
Next:;
		}
	}
#endif
	class CMicroThreadQuitException : public CRuntimeException {};

	static void	InnerCallBack(CMicroThread*p);
	//	fn_ɃR[obN

	static IMemoryAllocator* pDefaultAllocator_;
};
#endif


} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
