#include "stdafx.h"
#include "yaneThreadPooler.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

//	worker threadqueueȂ^XNŝ
void CThreadPoolerThread::ThreadProc(){
	while (IsThreadValid()){
		smart_ptr<function_callback> fn;
		fn = queue->getRequest();
		if (fn.isNull()) break;	//	dւ
		queue->incInvokeCount();	//	s̃^XNJEg𑝂₷
		fn->run();
		queue->decInvokeCount();	//	s̃^XNJEg炷
	}
	queue->decThreadCount();		//	s̃XbhJEg炷
}

////////////////////////////////////////////////////////////////////

LRESULT	CThreadPooler::StartThread(int nThreadNum){
	//	܋NĂXbhׂĒ~
	ClearAllThread();

	//	ꂼ̃Xbh𐶐`N
	for(int i=0;i<nThreadNum;i++){
		CThreadPoolerThread* p = new CThreadPoolerThread(m_pQueue);
		p->CreateThread();
		m_aThread.insert(p);
	}

	return 0;
}

///	ێĂXbhׂĒ~
void	CThreadPooler::ClearAllThread(){
	/*
	for(UINT i=0;i<GetThreadList()->size();i++){
		(*GetThreadList())[i]->InvalidateThread();
	}
	*/
	//	l邪Ałqueueɓ`B
	//	queue烊NGXg炨Ƒҋ@ĂXbh
	//	΂ċcallbackԂƂɂďI\

	m_pQueue->invalidateAllThread();

	//	smart_ptrȂ̂ŁA폜ƂCThread̃fXgN^
	//	ĂяoÂȂStopThreadĂ̂łŐ
	//@悤Ɏv邪AhNX̏ꍇ͂ł͂ȂB
//	for(int i=0;i<(int)m_aThread.size();++i) m_aThread[i]->StopThread();
	m_aThread.clear();
	m_pQueue->setValid(true); // invalidatêŌɖ߂Ă
}

void	CThreadPooler::Invoke(const smart_ptr<function_callback>&fn){
	m_pQueue->setRequest(fn);
}

LRESULT	CThreadPooler::wait(int nTimeOut/*=-1*/){
	LRESULT lr = m_pQueue->waitAllThreadEnded(nTimeOut);
	if (lr!=0) return lr;
	ClearAllThread();	//	SXbh̒~҂
	return 0;
}

///	InvokêɏĂȂd̐0ɂȂtrue
bool	CThreadPooler::IsDone() const{
	CThreadPooler *pThis = const_cast<CThreadPooler*> (this);
	return pThis->m_pQueue->isDone();
}

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd
