// yaneHWndManager.h : HWND manager
//		programmed by yaneurao(M.Isozaki) '02/03/08
//
/**
	̃NXAThreadLocal̃TvƂčĂ݂A
	ۂ class CAppManager ʂHWND͎擾ł̂ŁA
	Ȃi΁j
*/

#ifndef __yaneHWndManager_h__
#define __yaneHWndManager_h__


namespace yaneuraoGameSDK3rd {
namespace Window {

class IHWndManager {
public:
	virtual HWND GetHWnd()=0;				/// ̃XbhɑΉHWND̎擾
	virtual void SetHWnd(HWND hWnd)=0;		///	̃XbhɑΉHWND̐ݒ
	virtual ~IHWndManager(){}
};

class CHWndManager : public IHWndManager {
/**
	̃XbhɑΉHWND̐ݒA擾B

		CHWndManager::GetObj()->GetHWnd();
	̂悤ɂĎg܂B

	ƂɃXbh͈قȂ݌vɂ͂Ȃ̂ŁA
	XbhID玩̃Xbh̏鑋HWND킩͂łB

*/
public:
	virtual HWND GetHWnd();
	/**
		̃XbhɑΉHWND̎擾
		݂ȂƂNULLԂ
	*/
	virtual void SetHWnd(HWND hWnd);
	/**
		̃XbhɑΉHWND̐ݒ
	*/

	static CHWndManager* GetObj() { return m_vHWndManager.get(); }
	///	singletonȃ|C^̎擾

protected:
	static singleton<CHWndManager> m_vHWndManager;

	ThreadLocal<HWND>	m_hWnd;
};

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd

#endif
