/*
	singleton	: singleton template
		programmed & desinged by yaneurao(M.Isozaki) '02/03/13
*/

#ifndef __YTLSingleton_h__
#define __YTLSingleton_h__

#ifdef USE_MEMORY_STATE
	#include "../Auxiliary/yaneMemory.h"
#endif

#include "../Thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace YTL {

template <class T>
class singleton {
/**
	̃|C^́A
	KvɔꂽƂɎn߂objectnew悤ȃ|C^

	񃍁[JstaticIuWFNgƂāA

	class CHoge{
	public:
		static singleton<CHoge> m_obj;
		static CHoge* GetObj() { return m_obj->get(); }
	};
	̂悤ɎgđvIIuWFNg̉̂ɂĂۏ؂

	ƂÃNX́AЂƂ̃NXɂA݂łȂB
	܂ɁAL̂悤staticƂĂgȂ(;LD`)
*/
public:
	singleton() {
	//	͉sȂȂ
	//	Ƃ񃍁[JstaticIuWFNg
	//	̖肪̂ŁÃIuWFNg̏ɂĂ
	//	sȂĂ͂Ȃ
	}

	~singleton() { Release(); }

	///	|C^̂ӂ邽߂̎d|
	T& operator*() { return *get(); }
	T* operator->() { return get();	}
	T* get() { CheckInstance(); return m_lpObj; }

	///	IuWFNgNullǂ؂
	bool	isNull() const { return m_lpObj == NULL; }

	///	IuWFNgIɉ̂
	///	ifXgN^łĂj
	void Release();

	void CheckInstance();
	/**
		CX^X݂̂̃`FbNsȂA
		݂ȂΐB{AIɍsȂKv͖A
		̃IuWFNĝɏ̎Ԃ̂A
		A^Cɂ̏sȂĂ͍Ƃɂ́A
		iKvȂ̂킩Ă΁jOɐsȂĂ
		ƂŁAłB
	*/

#if 0
//#ifdef USE_MEMORY_STATE
		if (CMemoryState::IsActive()){
		/**	LogL^(BeginSnap`EndSnap̍Œ)
			̂ƂɐꂽIuWFNǵAEndSnap̂ƁA
			operator new/deletẽI[o[[h܂ł
			IuWFNgR[obNɂĉ̂ĂKv
		*/
			//	callbackIuWFNgp
			smart_ptr<function_callback> fn(
				function_callback_v::Create((void(singleton<T>::*)())Release,this)
			);
			CMemoryState::RegistCallBack(fn);
			//	callback˗
		}
//#endif
#endif

protected:
	static CCriticalSection m_cs;
	//	́AVOXbh́ApȂ

	static T*	m_lpObj;
	//	staticŗpӂ邱ƂŁA
	//	N(񃍁[JstaticIuWFNg̏O)NULL
	//	ł邱Ƃۏ؂
};

///////////////////////////////////////////////////////////////////////////////////////

//	static ȃIuWFNg
template <class T> T* singleton<T>::m_lpObj = 0;
template <class T> CCriticalSection singleton<T>::m_cs;

}}

#include "../AppFrame/yaneAppInitializer.h"	//	}`Xbh삩ǂ擾

namespace yaneuraoGameSDK3rd {
namespace YTL {

//	̎ŕKvƂȂCAppInitializer̂ȂsingeltonpĂ̂Ł
//		includeȂƁAzQƂɂȂĂ܂
template <class T> void	singleton<T>::CheckInstance() {
	if (m_lpObj==NULL) {
		if (CAppInitializer::IsMultiThread()){
		//	}`Xbh́Adouble-checked locking
			CCriticalLock guard(&m_cs);
			if (m_lpObj==NULL){
				m_lpObj = new T;
			}
		} else {
			m_lpObj = new T;
		}
	}
}

template <class T> void	singleton<T>::Release() {
	if (m_lpObj!=NULL) {
		if (CAppInitializer::IsMultiThread()){
		//	}`Xbh́Adouble-checked locking
			CCriticalLock guard(&m_cs);
			if (m_lpObj!=NULL){
				delete m_lpObj;
				m_lpObj = NULL;
			}
		} else {
			delete m_lpObj;
			m_lpObj = NULL;
		}
	}
}

} // end of namespace YTL
} // end of namespace yaneuraoGameSDK3rd

#endif
