//
//	AvP[VCjVCU
//		yaneuraoGameSDK 2nd̂߂̃CjVCUB
//		CɂȂΎRɃJX^}CYĎgĂȁOO
//

#ifndef __yaneAppInitializer_h__
#define __yaneAppInitializer_h__

#include "../Window/yaneWinHook.h"

namespace yaneuraoGameSDK3rd {
namespace AppFrame {

class CAppCallbackList {
public:
	void	RegistInitCallback(const smart_ptr<function_callback>& p){
		GetInitCallbackList()->push_back(p);
	}
	void	RegistExitCallback(const smart_ptr<function_callback>& p){
		GetExitCallbackList()->push_back(p);
	}

	void	InitCallback();	//	RegistInitCallbackꂽ֐ԂɌĂяo
	void	ExitCallback();	//	RegistExitCallbackꂽ֐ԂɌĂяo

	smart_list_ptr<function_callback> * GetInitCallbackList()
	{ return &m_listInitFunc;}
	smart_list_ptr<function_callback> * GetExitCallbackList()
	{ return &m_listExitFunc;}

protected:
	//	R[obNp
	smart_list_ptr<function_callback> m_listInitFunc;
	//	ĨR[obNp
	smart_list_ptr<function_callback> m_listExitFunc;
};

class CAppInitializer {
/**
	AvP[V̂߂̃NX

	RXgN^WinMain炻̃p[^̂܂ܓnĂˁB

	񃍁[JstaticIuWFNgɂR[obN\񂪏o܂B
		RegistInitCallback(R[obN\񂷂֐);
		RegistExitCallback(R[obN\񂷂֐);
	Ƃ΁ARXgN^ƃfXgN^ɂāÅ֐
	IɃR[obN܂Bio^j

*/
public:

#ifndef COMPILE_YANE_PLUGIN_DLL
	///	WinMain炻̃p[^̂܂ܓnĂˁB
	CAppInitializer(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow);
#else
	CAppInitializer( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved);
	///	DllMaiñp[^̂܂ܓnălIDll̏łႤ
	///	GetCmdLine()ŁAœnꂽlpReserved擾ł܂
#endif

	///	̃fXgN^RegistExitCallbackĂ֐Ăяo
	~CAppInitializer();

	///	singletonʂĎ擾
	static HINSTANCE GetInstance()		{ return GetObj()->GetInstance_(); }
	static HINSTANCE GetPrevInstance()	{ return GetObj()->GetPrevInstance_(); }
	static LPSTR	 GetCmdLine()		{ return GetObj()->GetCmdLine_(); }
	static int		 GetCmdShow()		{ return GetObj()->GetCmdShow_(); }

#ifndef COMPILE_YANE_PLUGIN_DLL
	/**
		Dll쐬ɂ́Å֐͖Ȃ̂ŒӂKvI
	*/
	///		InitĂяôƂɃR[obNė~̂o^Ă
	static void	RegistInitCallback(const smart_ptr<function_callback>& p)
	{	GetCallbackObj()->RegistInitCallback(p); }
#endif

	///		IɃR[obNė~̂o^Ă
	static void	RegistExitCallback(const smart_ptr<function_callback>& p)
	{	GetCallbackObj()->RegistExitCallback(p); }

	static bool	IsMultiThread() { return m_bMultiThread; }
	/**
		}`Xbh삩ǂԂ
		̃NXInit\bhĂяoȍ~AfXgN^
		Ăяo܂ł̊ԁAtrueɂȂ
	*/

	//////////////////////////////////////////////////////////////

	///		singletonIuWFNg̎擾
	static CAppInitializer* GetObj() { return m_vObj; }

	///		WinMainœnĂp[^̎擾
	HINSTANCE GetInstance_()		{ return m_hInstance; }
	HINSTANCE GetPrevInstance_()	{ return m_hPrevInstance; }
	LPSTR	 GetCmdLine_()			{ return m_lpCmdLine; }
	int		 GetCmdShow_()			{ return m_nCmdShow; }


protected:

	//	instance parameter...
	HINSTANCE	m_hInstance;
	HINSTANCE	m_hPrevInstance;
	LPSTR		m_lpCmdLine;
	int			m_nCmdShow;

private:
	//	singletonIuWFNg
	static CAppInitializer* m_vObj;

	static singleton<CAppCallbackList>	m_AppCallBackObj;
	static CAppCallbackList* GetCallbackObj()
	{ return m_AppCallBackObj.get(); }

	//	}`Xbh삩ǂԂ
	//	Initȍ~trueɂȂ
	static bool m_bMultiThread;
};

} // end of namespace AppFrame
} // end of namespace yaneuraoGameSDK3rd

#endif
