// yaneCOM.h :
//	initialize/terminate COM
//
//	COMgpŏƍŌŏ^IKvȂ̂ŁA
// Ȃ񂪕KvɂȂĂ...
//

#ifndef __yaneCOMBase_h__
#define __yaneCOMBase_h__


//	#include "../YTL/yaneThreadLocal.h"
//	stdafx.hœǂݍł
#include "../Thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class CCOMBase {
/**
	COḾAXbhx[XŏȂ΂ȂȂB
	āACOMgOɂ́Ainc_ref֐ĂяoA
	COMgIƂɂ́Adec_refĂяoΗǂNX
*/
public:
	static LRESULT inc_ref();			// COM̎QƃJEg̉Z
	static LRESULT dec_ref();			// COM̎QƃJEǧZ

protected:
	static ThreadLocal<int> m_nCount;	//	QƃJEgێĂ
	static CCriticalSection m_cr;
	static CCriticalSection* GetCriticalSection() { return& m_cr; }
};

template <class T>
class CCOMObject {
/**
	CoCreateInstance`ReleaseInstancewrapper
	T COMIuWFNg
*/
public:
	LRESULT CreateInstance(REFCLSID clsid,REFIID guid){
		CCOMBase::inc_ref();
		Release();	//	Ôł
		if (FAILED(::CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,
			guid, (VOID**)&pObj))){
			pObj = NULL;
			CCOMBase::dec_ref();
		}
		//	CoCreateInstance̊֐̎sƁApObjNULLȂΎsƂ݂Ȃ
		return pObj==NULL?1:0;
	}
	///	CX^X𐶐

	LRESULT Release(){
		LRESULT lr = 0;
		if (pObj!=NULL){
			pObj->Release();
			pObj = NULL;
			lr = CCOMBase::dec_ref();
		}
		return lr;
	}
	///	CX^X

	T	get() const { return pObj; }
	///	IuWFNg擾

	operator T* () const { return get(); }
	///	Öٕϊq
	T& operator*() const  {return *get(); }
	T* operator->() const {return get(); }
	///	-> Zq`Ă

	CCOMObject() : pObj(0) {}
	virtual ~CCOMObject() { Release(); }

protected:
	T		pObj;	//	COMIuWFNg
};

class CLoadLibraryWrapper {
/**
	LoadLibrary`ReleaseLibrarywrapper
*/
public:
	///	DLLLoad
	LRESULT Load(const string& libname) {
		m_hDLL = LoadLibrary(libname.c_str());
		return m_hDLL==NULL?1:0;
	}

	///	DLLRelease
	void Release(){
		if (m_hDLL!=NULL){
			::FreeLibrary(m_hDLL);
			m_hDLL = NULL;
		}
	}

	///	DLL̊֐AhX̎擾
	void* GetProc(const string& funcname){
		return ::GetProcAddress(m_hDLL,funcname.c_str());
	}

	///	ǂݍDLL̃CX^XԂ
	HINSTANCE Get() const { return m_hDLL; }

	CLoadLibraryWrapper() { m_hDLL = NULL; }
	virtual ~CLoadLibraryWrapper() { Release(); }
protected:
	HINSTANCE m_hDLL;
};

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

#endif
