#include "stdafx.h"
#include "yaneCPUID.h"

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

//	static object
singleton<CCPUID> CCPUID::m_obj;

/*
	CPU ID̐ɂĂ
		http://www.dinop.com/vc/cpuidentify.html
	QlɂȂ
*/

int		CCPUID::GetID(){
	if (m_nCPUID) return m_nCPUID;	//	łɌς݂Ȃ΁AԂ

	int nID,nErr = 0;

	//	VC++5łPentiump̖߂͎gȂB^^;
	#define cpuid __asm _emit 0x0F __asm _emit 0xA2

	//	CPU
	_asm {
		//	CPUID߂͎ĝH
		pushfd
		pop		eax
		mov		ebx, eax
		xor		eax,0x200000	//	toggle bit21
		push	eax
		popfd
		pushfd
		pop		eax
		cmp		eax,ebx
		jz		NO_CPUID

		mov		eax,1			//	get version info
		cpuid
		mov		nID,edx
		jmp		CPUID_EXIT

	NO_CPUID:
		mov		nErr,1		//	486 lower
	CPUID_EXIT:
	}

	if (nErr) {
		//	CPUID߂ɎsĂ̂486ȑO
		m_nCPUID = 1;
	} else if ((nID & 0x800000)==0) {		//	bit23
		//	MMX̃T|[grbgĂȂ̂ŔMMX
		if ((nID & 0x8000)==0) {
			//	CMOVT|[gĂȂ̂Pentium Pro
			m_nCPUID = 2;
		} else {
			//	CMOVT|[gĂ̂Pentium Proȍ~
			m_nCPUID = 3;
		}
	} else {
		//	MMXΉ
		m_nCPUID = 4;

		//	SSEΉ
		if (nID & 0x2000000) m_nCPUID+=8;	//	bit25

		//	SSE2Ή
		if (nID & 0x4000000) m_nCPUID+=16;	//	bit26
	}
	return m_nCPUID;

	#undef cpuid
}


} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd
