// yaneIMEWrapper.h : easy ime wrapper
//		programmed by yaneurao(M.Isozaki) '02/03/08
//

#ifndef __yaneIMEWrapper_h__
#define __yaneIMEWrapper_h__


#include <imm.h>	// for ImmAssociateContext

#pragma comment(lib,"imm32.lib")

namespace yaneuraoGameSDK3rd {
namespace Auxiliary {

class IIMEWrapper {
public:
	virtual void Show()=0;		/// IME̕\
	virtual void Hide()=0;		///	IME̔\
	virtual ~IIMEWrapper(){}
};

class CIMEWrapper : public IIMEWrapper {
/**

	IME̕\E\𐧌䂵܂B
	ShowAŌĂяoĂA
	xHideĂяoIME͏܂B
	iQƃJEg͎Ă܂j

		CIMEWrapper::GetObj()->Show();
		CIMEWrapper::GetObj()->Hide();
	̂悤ɂĎg܂B

	ӁF
	EBhDNXŁAtXN[[hɂȂƂɂ́A
	IɃItɂȂ悤ɂĂ܂B
	́ADirectDrawAIME(GDI)𖳎ē]Ă܂߂łB

	ꉞAClipperd|Ă΂͉ł̂łA
	tXN[FlipsȂݒ肾ƁAIME͂܂A
	Q[IMEgƂ͖낤ƂƂŁAdlɂ܂B
	CɓȂꍇ͂̂Q_ɋCȂύX悤ɂĂB

	܂AIME̕\E\WindowƊ֘AčsȂ邽߁A
	WindowOHideĂӖȂ̂ŒӂĂB
*/
public:
	virtual void Show();	/// IME̕\
	virtual void Hide();	///	IME̔\

	CIMEWrapper() { m_nStat=0; }
	virtual ~CIMEWrapper() {
	//	if (m_nStat==2) Show();	//	ĂȂΏo
	//	singletoñfXgN^singletoňĂяo͋֎~
	}

	static CIMEWrapper* GetObj() { return m_vIMEWrapper.get(); }
	/**
		singletonȃ|C^̎擾

		Aproxy_ptrȂ̂ŁA񃍁[JstaticIuWFNg
		RXgN^QƂĂ͂Ȃ
	*/

protected:
	static singleton<CIMEWrapper> m_vIMEWrapper;

	int m_nStat;
	//	݂̏ 0:s 1:Show 2:Hide
	//	˘AIȌĂяoh~
};

} // end of namespace Auxiliary
} // end of namespace yaneuraoGameSDK3rd

#endif
