// yaneDirectDraw.h
//	 This is DirectDraw wrapper.

#ifndef __yaneDirectDraw_h__
#define __yaneDirectDraw_h__


#include "../Auxiliary/yaneCOMBase.h"

namespace yaneuraoGameSDK3rd {
namespace Draw {

class CDirectDraw {
/**
	̃NX́ADirectDrawCOMIuWFNgwrapper
*/
public:

	LPDIRECTDRAW Get() const { return m_vDirectDraw.get(); }
	/**
		RXgN^ŎIDirectDraw݂̏̂ŁA
		̊֐ŁAIDirectDraw擾΂łB
	*/

	int	GetStatus() const { return m_nStatus; }
	/**
		DirectDraw̏󋵂ɂāAUgԂ
		0:ok
		1,2:DirectX3ĂȂ
		3:HELɎsBHALɂ͐BDirectDraw͎g
		4:HEL,HAL̏ɎsBDirectDraẃȀԂł͎gȂB
	*/

	CDirectDraw(bool bEmulationOnly=false);
	/**
		bEmulationOnly == trueȂHELœ
		2Dp̃Q[Ȃ΁AHELœقǂ
	*/
	
	virtual ~CDirectDraw() {}

protected:
	CCOMObject<LPDIRECTDRAW>	m_vDirectDraw;
	CCOMObject<LPDIRECTDRAW>*	GetDirectDraw() { return& m_vDirectDraw;}
	int		m_nStatus;	//	̕ϐ̈ӖɂĂGetStatusQƂ̂
};

class CDirectDrawSurfaceManager {
/**
	sNZtH[}bgׂ˂I
*/
public:
	int GetSurfaceType(LPDIRECTDRAWSURFACE);
	///	T[tF[X̃T[tF[X^Cv𒲂ׂ
	/**
		0:	T[tF[X̃^Cv̎擾Ɏs
		1:	T[tF[X̃^Cv̓肪oȂ
			iȉ̈ȊOƎv)
		2:	8bpp
		3:	16(RGB565)
		4:	16(RGB555)
		5:	24(RGB888)
		6:	24(BGR888)
		7:	32(XRGB8888)
		8:	32(XBGR8888)

		10:	16+a4(ARGB4565)	//	ۂ́AꂪԂĂ邱Ƃ͖
		11:	16+a4(ARGB4555)	//	ۂ́AꂪԂĂ邱Ƃ͖
		12:	32(ARGB8888)	//	ۂ́AꂪԂĂ邱Ƃ͖
		13:	32(ABGR8888)	//	ۂ́AꂪԂĂ邱Ƃ͖
	*/
};

class CDirectDrawClipper {
public:
	LRESULT SetClipper(LPDIRECTDRAW lpDraw,LPDIRECTDRAWSURFACE lpPrimary,HWND hWnd);
	//	Nbv

	void	Release();						//	Nbp

	CDirectDrawClipper() : m_lpClipper(NULL) {}
	virtual ~CDirectDrawClipper() { Release();}

protected:
	LPDIRECTDRAWCLIPPER m_lpClipper;
};

} // end of namespace Draw
} // end of namespace yaneuraoGameSDK3rd

#endif // __yaneDirectDraw_h__
