//	yaneVolumeFader.h :
//		programmed by yaneurao '00/03/12
//

#ifndef __yaneVolumeFader_h__
#define __yaneVolumeFader_h__


#include "yaneAudioMixer.h"
#include "../Timer/yaneIntervalTimer.h"

namespace yaneuraoGameSDK3rd {
namespace Multimedia {

class CVolumeFader {
/**
	I[fBĨ~LVOpNXCAudioMixer𗘗pāA
	MIDIACDAWAVEɑ΂ċ[IȃtF[hC^tF[hAEgB
	CDɑ΂tF[hĆAZpIɂHłB

	class CAudioMixerQƂ邱ƁB

	tF[h́ACIntervalTimerɂ邪ACAppBase::IsThreadValid
	ĂяoȂCallBackȂB
	āACVolumeFaderFadeOut/FadeInĂяoƂ́ASleepĂ
	ӖȂBCAppBase::IsThreadValidĂяo`惋[v̂Ȃ
	głB

	tF[hAEǵǍAw肵bŁAtF[hAEĝ
	̂ƁAȍĐ~AResetVolumeĂяoāAƂ̃H[
	ɖ߂ĂKvB

	܂ÃNXH[tF[hĂȂƂɁA
	H[ύXsȂꂽƂ̂ƂlāA
	tF[hJnƂɁAH[`FbNāA
	H[class CAudioMixer ̏H[ƂĐݒ肷
	sȂĂB
*/
public:
	LRESULT ResetVolume(eAudioMix e);			///	{[lɖ߂

	////////////////////////////////////////////////////////////////////////
	/// dwTime[ms]Ƀ{[̃tF[h͊
	LRESULT FadeOut(eAudioMix e,int dwTime);	///	tF[hAEgJn
	LRESULT FadeIn(eAudioMix e,int dwTime);		///	tF[hCJn
	bool	IsFade(eAudioMix e)const;			///	tF[hȂ̂H

	LRESULT FadeOut(eAudioMix e,int dwTime,
		const smart_ptr<function_callback>& fn);
	/**
		fadeout IɁAʒm邽߂̃R[obNwł
	*/

	LRESULT FadeIn(eAudioMix e,int dwTime,
		const smart_ptr<function_callback>& fn);
	/**
		fadein IɁAʒm邽߂̃R[obNwł
	*/

	void	StopFade();							///	tF[h~

	CVolumeFader() : m_bTimer(false) {}
	virtual ~CVolumeFader() { Stop(); }
protected:
	class CVolumeFadeInfo {
	public:
		CTimer		m_Timer;		//	Fadê߂Timer
		DWORD		m_dwWholeTime;	//	FadeJnI܂ł̎
		bool		m_bFadeIn;		//	FadeInȂ̂?
		bool		m_bFadeOut;		//	FadeOutȂ̂?
		bool		m_bChanged;
	//	݁ÃNXH[ĂԂH
	//	˂̃tOfalsêƂɁAFadeIn/FadeOutw肳΁A
	//	݂̃H[̂Ƃ̃IWiH[Ƃ
	//	f

		smart_ptr<function_callback> m_fn;	//	FadeIcallback

		CVolumeFadeInfo() {
			m_bFadeIn = m_bFadeOut = m_bChanged = false;
		}
	};

	CAudioMixer		m_AudioMixer;
	CVolumeFadeInfo	m_FadeInfo[4];

	void	TimerProc();	//	R[obN֐
	void	Start();		//	R[obNJn
	void	Stop();			//	R[obNI
	bool	m_bTimer;		//	R[obN[v
	bool	IsTimer() const { return m_bTimer; }

	bool	CheckCallBack(eAudioMix e);
	//	fadȅI^C~OȂ̂ŁAKv΃R[obNsȂ
	//	callbacksȂƂtrue
	LRESULT _FadeOut(eAudioMix e,int dwTime,bool bCheckCallBack);
	LRESULT _FadeIn(eAudioMix e,int dwTime,bool bCheckCallBack);
	//	bCheckCallBack̗LƖiŎgpj
};

} // end of namespace Multimedia
} // end of namespace yaneuraoGameSDK3rd

#endif
