// yaneMutex.h :
//
//	programmed by M.Isozaki '99/06/19
//	nh擾̂Œxł:p

#ifndef __yaneMutex_h__
#define __yaneMutex_h__


namespace yaneuraoGameSDK3rd {
namespace Thread {

class IMutex {
public:
	virtual LRESULT Open(const string& strMutexName)=0;
	virtual void Wait()=0;
	virtual void Release()=0;
	virtual ~IMutex(){}
};

class CMutex : public IMutex {
/**
	MutexNXłBnrxłP݂ȂݔrړIƂ܂B
	QdN̖h~ȂǂɎg܂B
	QdNh~́Aclass CSingleApp QƂ邱ƁB

	XbhƂ̑ݔrȂ class CCriticalSection p邱ƁB
	̂ق͒fRyłB

*/
public:
	virtual LRESULT Open(const string& strMutexName);
	/**
	@strMutexNaméA~[ebNXiCӂɂėǂj

	@Ԃl
	@0 : ɓ݂̂̂͑ȂLlI
	@1 : ɓ݂̂̂B(error)˂̂Waitő҂Ɨǂ
	  2 : ̃Z}tHA~[ebNXAҋ@\ȃ^C}AWuA
		t@C}bsOIuWFNĝꂩ̖Oƈv̂ŃG[
	*/

	virtual void Wait();
	/**
		OpenłPԂĂĂƂɌĂяoāA
		Llł̂҂B
	*/
	virtual void Release();
	/**
		Mutex
		fXgN^IɂReleaseĂяôŁA
		ɉ̂Ȃ΁AIɌĂяoKv͖B
	*/

	CMutex();
	virtual ~CMutex();
protected:
	HANDLE	m_hMutex; // Mutex nh 
};

class IMutexSection {
public:
	virtual LRESULT	Enter(const string& strMutexName)=0;
	virtual void	Leave()=0;
	virtual ~IMutexSection(){}
};

class CMutexSection : public IMutexSection {
/**
		MutexɂLock`unlockł
		class CCriticalSectionƓoŎg܂
*/
public:
	virtual LRESULT	Enter(const string& strMutexName);	///	MutexSectionɓ
	/**
		ԂlF
@@@@@OF
		@PF̃Z}tHA~[ebNXAҋ@\ȃ^C}AWuA
		t@C}bsOIuWFNĝꂩ̖Oƈv̂ŃG[
	*/

	virtual void	Leave();					///	MutexSectiono

	/**
		fXgN^łCMutex̂ŁÂƂ
		IMutex͉B
	*/

protected:
	CMutex m_vMutex;
};

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
