/*
	XbhŗL̃IuWFNgpӂ邽߂̃ev[g

		programmed & designed by yaneurao '02/03/10
*/

#ifndef __YTLThreadLocal_h__
#define __YTLThreadLocal_h__


#include "../Thread/yaneCriticalSection.h"
#include "../YTL/singleton.h"

namespace yaneuraoGameSDK3rd {
namespace Thread {

class ThreadLocalBase;
class ThreadLocalBaseHelper {
/**
	class ThreadLocalBase ̂߂SingletonIuWFNg
	ilocalȃIuWFNg͕̏ŝ߂̂KvɂȂj

	class ThreadLocalBase ĂяôŁA
	̊֐͒ڌĂяoĎgƂ̂ł͂ȂB
*/
public:
	static ThreadLocalBaseHelper* GetObj(){ return m_obj.get(); }

	///	`FCɒǉ^`FC
	void	insert(ThreadLocalBase*p);
	void	erase(ThreadLocalBase*p);

	///	Xbh~Ƃɂ̃XbhĂяo
	void	OnThreadEnd();

	///	WinMain甲ƂɁACAppInitializerR[obN
	void	OnExit();

	//	ACAppInitalizerɁAOnExit̃R[obN˗
	ThreadLocalBaseHelper();

protected:
	static singleton<ThreadLocalBaseHelper> m_obj;

	///	`FC̎擾
	list_chain<ThreadLocalBase>* GetChain(){ return &m_threadlocal_list;}
	list_chain<ThreadLocalBase>	m_threadlocal_list;

	//	̃`FCƂ̂߂̃NeBJZNV
	CCriticalSection	ms_cr;
	CCriticalSection*	GetCriticalSection() { return &ms_cr; }
};

class ThreadLocalBase {
/**
	class ThreadLocal ev[ĝ߂̊NX
	class ThreadLocal QƂ̂ƁB
*/
public:
	virtual void	Clear()=0;
	virtual void	ClearAll()=0;
	virtual void	SetExit(bool)=0;
	virtual ~ThreadLocalBase(){} // merely place holder

	static void	OnThreadEnd()
	{	ThreadLocalBaseHelper::GetObj()->OnThreadEnd(); }
	/**
		Xbh͏IƂɕK̊֐ĂяoāA
		ׂĂThreadLocal̃CX^XClearĂяoȂ
		ȂȂ
	*/

	///	`FCɒǉ^`FC
	static void	insert(ThreadLocalBase*p)
	{	ThreadLocalBaseHelper::GetObj()->insert(p); }
	static void	erase(ThreadLocalBase*p)
	{	ThreadLocalBaseHelper::GetObj()->erase(p);	}

	///	WinMain甲OɁÅ֐ĂяoāA
	///	`FCf؂ĂKv
	///	Å֐CAppInitializer玩I
	///	R[obN̂Ń[U[͌ĂяoKv͖
	static void OnExit()
	{	ThreadLocalBaseHelper::GetObj()->OnExit(); }

};

template <class T>
class ThreadLocal : public ThreadLocalBase {
/**
	XbhŗL̃IuWFNgpӂ邽߂̃ev[gNX

	ThreadLocal<HWND> hWnd;

	Ƃ΁A
	hWnd = GetHWnd();
	Ƃ悤ɃXbhŗL̕ϐIɗpӂāA
	ɑoB

	邢́A
	ThreadLocal<HWND> hWnd;
	HWND	h = hWnd;
	Ƃ悤ɁA̑oB

	ׂẴXbh͏łƂɁA
	class CThreadLocalBase::OnThreadEnd() ĂяoāA
	ThreadLocal̃CX^XׂĂClearĂяoȂ΂ȂȂB

	iŌ̃Xbh́ÃNX̃fXgN^ۗLIuWFNg
	̂Ă̂ŁÅ֐ĂяoKv͖j

	@QlɂƗǂNX
	class CCOMBase
*/
public:
	///	f[^̐ݒ^擾
	void	Set(const T& t);
	T*		Get();

	///	vf܂ĂȂeXg
	bool	isEmpty();

	///	Öٕϊq
	operator T() { return *Get(); }

	///	Zq
	const T operator = (const T& t){
		Set(t);
		return *Get();
	}

	///	̃Xbhɑf[^NA
	virtual void	Clear();

	///	SXbhɑf[^NA
	virtual void	ClearAll();

	///	IIĂ̂Ȃ΁A`FCȎ͕sv
	virtual void	SetExit(bool b) { m_bExit = b; }

	ThreadLocal(): m_bExit(false)
		{ ThreadLocalBase::insert(this); }
	virtual ~ThreadLocal() {
		ClearAll();
		if (!m_bExit) { // IIĂȂƂ̂
			ThreadLocalBase::erase(this);
		}
	}

	//	processId  HWNDmap
	typedef map <DWORD,T*> mymap;

protected:
	mymap	m_map;
	mymap* GetMap() { return &m_map; }

	CCriticalSection	m_cr;
	CCriticalSection*	GetCriticalSection() { return &m_cr; }

	bool	m_bExit;
};

///////////////////////////////////////////////////////////////////////

template <class T>
T*	ThreadLocal<T>::Get() {
	/// ̃XbhɑΉf[^̎擾
	DWORD	dwThreadID = ::GetCurrentThreadId();

	CCriticalLock cl(GetCriticalSection());

	mymap::iterator it;
	it = GetMap()->find(dwThreadID);
	T* p;
	if (it==GetMap()->end()){
		//	HHnew邩H
		p = new T; // newĂ܂ŁI
		GetMap()->insert(pair<DWORD,T*>(dwThreadID,p));
		//	insertƂƁB

		//	gető݂Ȃ͖̂̂悤ȋCȂ..
	} else {
		p = it->second;
	}

	return p;
}

template <class T>
void	ThreadLocal<T>::Set(const T& t){
	///	̃XbhɑΉT̐ݒ
	DWORD	dwThreadID = ::GetCurrentThreadId();

	CCriticalLock cl(GetCriticalSection());

	mymap::iterator it;
	it = GetMap()->find(dwThreadID);

	T* p;
	if (it==GetMap()->end()){
		//	HH
		p = new T; // newĂ܂ŁI
		*p = t;	//	RsĂ܂B
		GetMap()->insert(pair<DWORD,T*>(dwThreadID,p));
	} else {
		*(it->second) = t;
	}

}

template <class T>
void	ThreadLocal<T>::Clear() {
	/// ̃XbhɑΉf[^̎擾
	DWORD	dwThreadID = ::GetCurrentThreadId();

	CCriticalLock cl(GetCriticalSection());

	//	ev[głusing std::mapĂ̂炵 > VC++6(;LD`)
	mymap::iterator it;
	it = GetMap()->find(dwThreadID);
	if (it==GetMap()->end()){
		//	HH
	} else {
		delete it->second;		//	̗vf
		GetMap()->erase(it);	//	Ă܂ŁI
	}
}

template <class T>
void	ThreadLocal<T>::ClearAll() {
	CCriticalLock cl(GetCriticalSection());
	mymap::iterator it;
	it = GetMap()->begin();
	while (it!=GetMap()->end()){
		delete it->second;
		it++;
	}
	GetMap()->clear();
}

template <class T>
bool	ThreadLocal<T>::isEmpty() {
	DWORD	dwThreadID = ::GetCurrentThreadId();
	CCriticalLock cl(GetCriticalSection());

	mymap::iterator it;
	it = GetMap()->find(dwThreadID);
	bool b = (it==GetMap()->end());	//	쐬f[^

	return b;
}

} // end of namespace Thread
} // end of namespace yaneuraoGameSDK3rd

#endif
