// yaneIntervalTimer.h :
//
//		C^[o^C}
//		iA蓮R[obNŎgj
//
//		programmed & designed by yaneurao(M.Isozaki) '02/03/20
//

#ifndef __yaneIntervalTime_h__
#define __yaneIntervalTime_h__


#include "yaneTimer.h"

namespace yaneuraoGameSDK3rd {
namespace Timer {

class IIntervalTimer {
public:
	virtual void	RegistCallBack(void*pVoid,DWORD dwNext,
			DWORD dwInterval,int nRepeat,
			const smart_ptr<function_callback>&fn)=0;
	virtual void	DeleteCallBack(void*pVoid)=0;
	virtual void	CallBack()=0;
	virtual void	SetTimer(const smart_ptr<ITimer>& pTimer)=0;

	virtual ~IIntervalTimer() {}
};

class CIntervalTimer : public IIntervalTimer {
/**
	C^[o^C}𓝍IɊǗ邽߂̃NX
		iA蓮R[obNŎgj
	R[obN̂́Aclass CAppBase AIsThreadValid̂Ȃ
	sȂĂ̂ŁACAppBase̗p҂́AIɍsȂKv͖

	gpF
	//	CAppFrame::MainThreadɂāDD
		//	R[obN̊֐`
		smart_ptr<function_callback> fn(
			function_callback_v::Create(&CTest::Test,&test)
		);
		//	R[obN̓o^
		GetMyApp()->GetIntervalTimer()->RegistCallBack(
			&test,	//	R[obNo^Ă̂
					//	폜邽߂̎ʎq
			3000,	//	3000msɈڂ̃R[obN
			1000,	//	1000msƂ
			10,		//	10R[obN
			fn
		);
*/
public:

	virtual void	RegistCallBack(void*pVoid,DWORD dwNext,
			DWORD dwInterval,int nRepeat,
			const smart_ptr<function_callback>&fn);
	/**
		R[obN̓o^sȂBpVoid́A^C}ʎqłA
		[U[̃NXthis|C^nĂ΁AƂŁA
		ʎqƂėpāAo^R[obN폜邱Ƃo

		dwNext	́APڂ̃R[obN͉~bȂ̂B
			̎ƂɁAR[obN

		dwIntervaĺAPڈȍ~̃R[obN̊ԊuB
			nRepeat1̂Ƃ͊֌WȂB

		nRepeat́AR[obNsȂ̂̎wB
		w肵񐔂AnCallBackԊũR[obNsȂ
		0Ȃ΁A񐔁AĂяo

		fńAR[obNׂ֐B
	*/

	virtual void	DeleteCallBack(void*pVoid);
	///		RegistCallBackŎw肵pVoidƈvR[obNׂď

	virtual void	CallBack();
	/**
		o^ĂR[obN̂AԂɂȂĂ̂
		ԂɌĂяoB

		class CAppBase ́AIsThreadValidŁÅ֐oĂ̂ŁA
		CAppBaseMainThreadł́AIɂ̊֐ĂяoKv͖B
	*/

	virtual void	SetTimer(const smart_ptr<ITimer>& pTimer);
	/**
		CFixTimerĝȂ΁A
		OɗpӂĂ^C}[ŒuƗǂB
		fBtHgłCTimerg
	*/

	CIntervalTimer();
	virtual ~CIntervalTimer();

protected:
	//	^C}[R[obN\
	struct CTimerInfo {
	void*					m_pVoid;
	/**
		^C}[ʎqi[U[̃NXthis|C^j
		nĂ΁ÃNX^C}݂̂邱Ƃo
	*/
	DWORD					m_dwCallBackTimer;
	//	^C}[A̎߂΁AR[obN

	DWORD					m_dwInterval;
	//	R[obN̊Ԋu[ms]

	int						m_nRepeat;
	//	cAĂяo(0Ȃ΁AɌĂяo)

	smart_ptr<function_callback>		m_fnCallBack;
	///	R[obNׂ֐

	bool					m_bDelete;
	///	̃IuWFNg͎̃tFCYŏ̂H
	///	iteratorsmart_iteratorł͖̂ŁAtFCYx点
	///	폜ĂKv
	bool	IsValid() const { return! m_bDelete; }
	///	ˁ@smart_list_ptr̃Ce[^ێĝɕKv

	};
	typedef smart_list_ptr<CTimerInfo> CTimerList;

	CTimerList	m_listTimerInfo;
	CTimerList* GetTimerInfo(){ return& m_listTimerInfo;}

	smart_ptr<ITimer>	m_pTimer;
	smart_ptr<ITimer>	GetTimer() const { return m_pTimer; }
	//	^C}[JEǵAŎ擾
};

} // end of namespace Timer
} // end of namespace yaneuraoGameSDK3rd

#endif
