#include "stdafx.h"
#include "yaneWinHook.h"

namespace yaneuraoGameSDK3rd {
namespace Window {

void CWinHookList::Add(IWinHook* hook)
{
	CCriticalLock cl(GetCriticalSection());
	{
		m_HookPtrList.push_back(hook);
	}
}

void CWinHookList::Del(IWinHook* hook){

	// HookTč폜Ă䂭i肤j
	CCriticalLock cl(GetCriticalSection());
		//	폜ɑ̃vZXĂƎʂ
	{
		for(hooklist::iterator it=m_HookPtrList.begin();it!=m_HookPtrList.end();) {
			if (*it==hook) {
				it = m_HookPtrList.erase(it);
			} else {
				it ++;
			}
		}
	}
}

void CWinHookList::Clear(){

	CCriticalLock cl(GetCriticalSection());
		//	폜ɑ̃vZXĂƎʂ
	{
		m_HookPtrList.clear();
	}
}

//	message dispatcher
//	  CWindowWndProcĂяôŁACriticalSectiońAeEBhDɂ݂邱ƂɂȂB
//	  ܂肱CriticalSectiońAbZ[W[vƁAɑΉ郁CXbhԂł̑ݔr̂߂̂̂łB
LRESULT CWinHookList::Dispatch(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc){

	{
		CCriticalLock cl(GetCriticalSection());
		hooklist::iterator it=m_HookPtrList.begin();
		while (it!=m_HookPtrList.end()) {
			LRESULT l;

//			Err.Out("%.8x %.8x %.8x",(DWORD)this,(DWORD)*it,((*it)->WndProc));
//			DWORD d = reinterpret_cast<DWORD>((*it)->WndProc);

			l = (*it)->WndProc(hWnd,uMsg,wParam,lParam);
			if (l) {
				return l; // ԂlƂĂOȊOȂ΃bZ[W͏ꂽƌȂ
			}
			it ++ ;
		}
	}

	if (pWndProc == NULL) {
		return ::DefWindowProc(hWnd,uMsg,wParam,lParam);
	} else {
		//	hookEBhD֐Ăяo
		return ::CallWindowProc(pWndProc,hWnd,uMsg,wParam,lParam);
	}
}

LRESULT CWinHookList::DispatchDlg(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam,WNDPROC pWndProc){
	{
		CCriticalLock cl(GetCriticalSection());
		hooklist::iterator it=m_HookPtrList.begin();
		while (it!=m_HookPtrList.end()) {
			LRESULT l;
			l = (*it)->WndProc(hWnd,uMsg,wParam,lParam);
			if (l) {
				return l; // ԂlƂĂOȊOȂ΃bZ[W͏ꂽƌȂ
			}
			it ++ ;
		}
	}
	return 0;
}

int		CMessagePooler::SetPoolData(UINT uMsg,WPARAM wParam,bool bWEnable,
		LPARAM lParam,bool bLEnable)
{
	//	󂫂T
	for(int i=0;i<(int)m_aInfo.size();++i){
		if (m_aInfo[i].isEmpty()){
			//	󂫂̂ŁAg
			m_aInfo[i].setMsg(uMsg,wParam,bWEnable,lParam,bLEnable);
			return i;
		}
	}
	//	󂫂Ȃ̂ŁAVɊmۂĂg
	CInfo info;
	info.setMsg(uMsg,wParam,bWEnable,lParam,bLEnable);
	m_aInfo.push_back(info);
	return m_aInfo.size()-1;
}

void	CMessagePooler::ClearPoolData(UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	//	T
	for(int i=0;i<(int)m_aInfo.size();++i){
		if (m_aInfo[i].isMsg(uMsg,wParam,lParam)){
			m_aInfo[i].init();
		}
	}
}

LRESULT CMessagePooler::WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	for(int i=0;i<(int)m_aInfo.size();++i){
		if (m_aInfo[i].isMsg(uMsg,wParam,lParam)){
			m_aInfo[i].pool(wParam,lParam);
		}
	}
	return 0;
}

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd
