// yaneWindow.h
//	window base class
//

#ifndef __yaneWindow_h__
#define __yaneWindow_h__


#include "yaneWinHook.h"
#include "../Thread/yaneCriticalSection.h"

namespace yaneuraoGameSDK3rd {
namespace Window {

class CWindowOption {
/**
	class CWindow Ŏw肷邽߂̃EBhDIvV
*/
public:
	string	caption;	///	LvV
	string	classname;	///	NX(captionƓłǂ)
	LPCTSTR dialog;		///	_CAȌꍇ́AŃ\[Xw肷ok
		/**
			stringɂĂȂ̂́A
			MAKEINTRESOURCE}NAPint^ILPCTSTRɃLXg
			::DialogBox֐ɓndlɂȂĂ邽߁Astringɂ
			MAKEINTERSOURCE}NgȂB

			IWindowhNXOnPreCreateI[o[ChāA

			virtual LRESULT OnPreCreate(CWindowOption &opt){
				opt.dialog = MAKEINTRESOURCE(IDD_DIALOG1);	//	_CAOȂ̂I
				return 0;
			}
			̂悤ɂ΁A_CAO\ł
	
		*/

	int		size_x;		///	̃TCY
	int		size_y;		///	c̃TCY
	LONG	style;		///	EBhDX^C̒ǉw	

	bool	bCentering;	///	EBhD͉ʑŜɑ΂ăZ^Oĕ\

	CWindowOption() {
		/**
			fBtHgłBKvΏׂ
			caption = "Ղ肿";
			classname = "YANEAPPLICATION";
			style = WS_VISIBLE | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU;
			size_x = 640; size_y = 480;
			bCentering = true;
		*/
		caption = "Ղ肿";
		classname = "YANEAPPLICATION";
		style = WS_VISIBLE | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU;
		size_x = 640; size_y = 480;
		bCentering = true;
		dialog = NULL;
	}
};

class IWindow {
public:
	virtual LRESULT		Create(CWindowOption& opt,HWND lpParent=NULL)=0;
	virtual HWND		GetHWnd()const=0;
	virtual LRESULT		SetWindowPos(int x,int y)=0;
	virtual void		ChangeWindowStyle()=0;
	virtual LRESULT		Resize(int sx,int sy)=0;
	virtual void		SetSize(int sx,int sy)=0;
	virtual void		UseMouseLayer(bool bUse)=0;
	virtual void		ShowCursor(bool bShow)=0;
	virtual bool		IsShowCursor()=0;
	virtual CWindowOption* GetWindowOption()=0;
	volatile virtual bool		IsMinimized()=0;
	virtual CWinHookList* GetHookList()=0;
	virtual void		ClearAllHook()=0;
	
	virtual void		SetResized(bool bResized)=0;
	// DirectDrawɂtXN[[hƂ
	//	EBhDɃTCŶŁÂƂɒʒmĂȂ
	//	EBhDNX̓ԂƈقȂ̂ɂȂĂ܂

	virtual void ChangeScreen(bool bFullScr)=0;
	virtual bool IsDialog() const=0;

	virtual ~IWindow(){}
};

class CWindow : public IWinHook , public IWindow{
/**
	𐶐NXłB̃NX̃CX^XA
	ɑΉ܂B}`EBhD̃T|[g͂ÂłB
	iǂtXN[ɂȂDirectDrawpĕ`悵ĂȏA
	ǂ悤Ƃbcj

	@`̂߂

	class CFastDrawg`sȂꍇA
	QƂĂBCFastDrawgĂƂ
	ʃTCYύXꍇACFastDraw::ChangeDisplayMode
	ĂяoĂB

*/
public:
	/// BeEBhÊ݂Ȃ΍Ō̃p[^Ŏw肷邱
	LRESULT		Create(CWindowOption& opt,HWND lpParent=NULL);

	HWND		GetHWnd()const { return m_hWnd; }	///	HWNDԂ

	LRESULT		SetWindowPos(int x,int y);			///	EBhDړ

	void		ChangeWindowStyle();
	///	݂̃XN[[hitXN[ or EBhD[hjp
	///	WindowStyleύX

	LRESULT		Resize(int sx,int sy);				///	̃TCY

	//	{staticȊ֐Ȃ̂IWindowoRŃANZXKv邽߁AȂ
	virtual void ChangeScreen(bool bFullScr){
		g_bFullScreen = bFullScr;
	}
	/**
		tXN[̃EBhD[h̐؂ւꍇA
		̊֐ĂяoƂꂼ̃EBhDɊւ
		ChangeWindowStyleĂяo
		AtXN[̃}`EBhDDirectDrawg֌WA
		T|[g
	*/

	void		SetSize(int sx,int sy);
	/**
		̃TCYiݒ݂̂ŎۂɕύX͂Ȃj
		ȂȂ̂KvɂȂ邩ƂƁAResizeChangeWindowStyle
		sƂQEBhDTCY̕ύXsȂƂɂȂāA
		̃[Vč邩B
		SetSize@ˁ@ChangeWindowStyleȂΈSB
	*/

	///		MouseLayer
	void	UseMouseLayer(bool bUse);
	///	\tgEFAJ[\̂߂ɃJ[\
	void	ShowCursor(bool bShow);
	///	n[hEFA}EXJ[\̕\^\
	bool	IsShowCursor();
	///	n[hEFA}EXJ[\̕\^\擾

	///	Ă̂̓_CAOH
	virtual bool IsDialog() const
	{	return const_cast<CWindow*>(this)->GetWindowOption()->dialog!=NULL; }

	///		Property
	DWORD		m_dwFillColor;		///	wiF

	CWindowOption* GetWindowOption() { return &m_opt; }
	///	WindowIvV̎擾BEBhDOȂΏĂǂB

	volatile bool	IsMinimized() { return m_bMinimized; }
	///	ŏĂ邩H

	///	bZ[WtbN邽߂̃|C^Xg
	///	iclass IWinHook ̃xN^j
	CWinHookList* GetHookList() { return &m_HookPtrList; }

	///	bZ[WtbN邽߂̃|C^XgNA
	void	ClearAllHook() { m_HookPtrList.Clear(); }

	CWindow();
	virtual ~CWindow();

	/**
		 j[݂̑`FbNAj[̂Ȃ
		tO(m_bUseMenu)XVB
		IɃj[OƂɁÃNX
		𔽉f̂Ɏg
	*/
	void CheckMenu() {
		if(m_hWnd!=NULL&&::GetMenu(m_hWnd)!=NULL){
			m_bUseMenu = true;
		}else{
			m_bUseMenu = true;
		}
	}

	///		̑
	static void	GetScreenSize(int &x,int &y);
	///	݂̉ʑŜ̃TCY̎擾

	static bool	IsFullScreen() { return g_bFullScreen; }
	///	tXN[H

	virtual void		SetResized(bool bResized) { m_bResized = true; }
	/**
		DirectDrawɂtXN[[hƂ
		EBhDɃTCŶŁÂƂɒʒmĂȂ
		EBhDNX̓ԂƈقȂ̂ɂȂĂ܂
		(CFastDrawĂяoĎg)
	*/

protected:
	HWND		m_hWnd;				//	EBhDnh
	bool		m_bFullScreen;		//	݂ǂ̃[hɍ킹đĂ̂H
	CWindowOption	m_opt;			//	EBhDIvV
	bool		m_bCentering;		//	EBhD͉ʑŜɑ΂ăZ^Oĕ\(default:true)

	static LRESULT CALLBACK gWndProc(HWND,UINT,WPARAM,LPARAM);
	static LRESULT CALLBACK gDlgProc(HWND,UINT,WPARAM,LPARAM);
	LRESULT Dispatch(HWND,UINT,WPARAM,LPARAM);	//	windows message dispatcher

	LRESULT		Initializer();	//	NAxEBhDNXo^
	//	tbNĂ邷ׂẴCX^Xւ̃`FC
	CWinHookList	m_HookPtrList;

	////////////////////////////////////////////////////////////////////////////
	//	}EXJ[\On/Off́AEBhDɑ΂鑮Ȃ̂
	//	EBhDNXSׂ
//	void	InnerShowCursor(bool bShow);
	bool	m_bShowCursor;			//	}EXJ[\̕\
	bool	m_bUseMouseLayer;		//	\tgEFA}EXJ[\gH

	//	EBhDTCYadjust
	void	InnerAdjustWindow(RECT&,CWindowOption&);

	//	j[tEBhDH
	bool	m_bUseMenu;

	//	ChangeWindowStyleSetSizẽtO
	bool	m_bResized;

	//	Windows{^Cv쐬ƂɁAbZ[Wnh
	//	tbN̂ŁÅ֐|C^ۑĂKvB
	WNDPROC	m_pWndProc;

	//	ŏĂ邩H
	volatile bool	m_bMinimized;

	bool IsWindowsClassName(const string& strClassName);
	//	WindowsŗpӂĂWindowNXǂ𒲂ׂ

/*
	//	j[mɑ݂邱ƂOɓ`Ă
	//	ɐmȃEBhDTCYȂ苁܂
	void		UseMenu(bool bUseMenu) { m_bUseMenu = bUseMenu; }
*/	//	Iɔ肷悤ɂ

	static	bool g_bFullScreen;			//	tXN[[hȂ̂H

	static CCriticalSection m_cs;
	static CCriticalSection* GetCriticalSection() { return &m_cs; }
	//	̏staticoQɃANZX邽߂̃NeBJZNV

	// override from CWinHook
	virtual LRESULT WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
};

class CDialogHelper {
/**
	_CAOƂ̃wpNX
*/
public:
	CDialogHelper(IWindow *pWin=NULL) : m_pWindow(pWin){ hook(pWin); }
	~CDialogHelper() { unhook(GetWindow()); }

	///	RXgN^œnтꂽ̂߂setter / getter
	IWindow* GetWindow() { return m_pWindow; }
	void SetWindow(IWindow*pWin) { unhook(m_pWindow); m_pWindow = pWin; hook(pWin); }

	///	HWND擾
	HWND	GetHWnd() { return GetWindow()->GetHWnd();}

	///	Rg[HWnd𓾂
	HWND	GetHWnd(int nEditControlID) { return ::GetDlgItem(GetHWnd(),nEditControlID);}

	///	GfBbgRg[etc..Aɕ\ĂeLXg擾
	///	(StaticText,Edit Control)
	string	GetText(int nEditControlID);

	///	GfBbgRg[etc..ɑ΂āAɃeLXgݒ肷
	///	(StaticText,Edit Control)
	LRESULT	SetText(int nEditControlID,const string& str);

	///	{^Ԃ̎擾
	///	(CheckBox,RadioButton)
	/**
		-1:̃{^݂͑Ȃ
		0:{^̃`FbN̓ItɂȂĂ܂B 
		1:{^̃`FbN̓IɂȂĂ܂B 
		2:{^̓OC\ismj̏ԂłB
		{^ABS_3STATE X^C܂ BS_AUTO3STATE X^CƂɂKp܂B 
	*/
	LRESULT	GetCheck(int nEditControlID);

	///	{^Ƀ`FbN
	///	(CheckBox,RadioButton)
	/**
		nCheck:
		0:{^̃`FbN̓It
		1:{^̃`FbN̓I
		2:{^̓OC\ismj̏Ԃ
	*/
	LRESULT SetCheck(int nEditControlID,int nCheck=1);

	/**
		{^͉񂪗̂ŁÃbZ[W
		hook`ŏ擾

		)
		{^Ȃ

			uMsg = WM_COMMAND , wParam = nEditControl
		Â悤
		OuMsgwParamyAɂăbZ[Wdispatcher
		o^ĂAƂŉ̓L[̃f[^𒲂ׂƗǂ

		 class CMessagePoolerQƂ̂ƁB
	*/
	CMessagePooler* GetPooler() { return &m_vPooler; }

	/**
		HookńAʎq߂̂ŁAGetPoolInföƂ
		nāAv[Ă擾Ďg
	*/

	int	HookButtonOnClick(int nEditControl)
	{	return GetPooler()->SetPoolData(WM_COMMAND,nEditControl,true,0,false); }
	/**
			{^hook
		)
			int nID = dialog.HookButtonOnClick(IDC_BUTTON1);
			while (IsThreadValid()){
				if (dialog.GetPoolInfo(nID)->isPool()){
				//	{^ƂI
					dialog.GetPoolInfo(nID)->reset();
					//	̃NA
				}
			}
	*/

	int	HookHScroolBar(int nEditControl)
	{	return GetPooler()->SetPoolData(WM_HSCROLL,0,false,(LPARAM)GetHWnd(nEditControl),true);}
	/**
		XN[o[hook

		bZ[WwParamɓ
			nScrollCode = (int) LOWORD(wParam); // XN[R[h
			nPos = (short int) HIWORD(wParam);	// XN[{bNXi܂݁j̈ʒu
	*/

	int	HookVScroolBar(int nEditControl)
	{	return GetPooler()->SetPoolData(WM_VSCROLL,0,false,(LPARAM)GetHWnd(nEditControl),true);}
	/**
		XN[o[hook

		bZ[WwParamɓ
			nScrollCode = (int) LOWORD(wParam); // XN[R[h
			nPos = (short int) HIWORD(wParam);	// XN[{bNXi܂݁j̈ʒu
	*/

	///	XN[o[ɂ́AɃwp֐Kv낤i肩j

	CMessagePooler::CInfo* GetPoolInfo(int nID)
	{	return GetPooler()->GetInfo(nID); }

	///	---- R{{bNXƃXg{bNXp̏ێNX ---
	/**
		lFR{{bNX͈ȉ̂Rނ
			PDW @@@@@@@@ɐĂ @@@@@GfBbg\
			QDhbv_E @@@{bNXŐ @@@GfBbg\ 
			RDhbv_EXg tH[JXƐ GfBbg֎~iXgÎ݁j

		hbv_E̍()̐ݒF
			\[XGfB^̃R{{bNXRg[̊Ǵ
			NbNĘgoB̘gɈĐ𒲐B
			ӁIFftHĝ܂܂ƍOȂ̂ŃXgڂȂB
	*/
	struct CListBoxInfo {
	typedef vector<string> mylist;

	mylist* GetList() { return& m_list;}
	const mylist* GetConstList() const { return& m_list; }

	///	Xg{bNXł邩ݒ^擾(Xg{bNXłȂȂR{{bNXj
	bool	IsListBox() const { return m_bListBox; }
	void	SetListBox(bool bListBox) { m_bListBox = bListBox; }

	///	Xgɒǉ
	/// nPos͒ǉBw肵OɒǉBnPos==-1(default)ł́AŏIsɒǉ
	void	AddString(const string& str,int nPos = -1){
		if (nPos==-1){
			GetList()->push_back(str);
			nPos = (int)GetList()->size()-1;
		} else {
			//	}1炷
			GetList()->push_back("");
			int size = (int)GetList()->size();
			for(int i=size-1;i>=nPos+1;--i){
				(*GetList())[i] = (*GetList())[i-1];
			}
		}
		::SendMessage(GetHWnd(),IsListBox()?LB_INSERTSTRING:CB_INSERTSTRING
			,(WPARAM)nPos,reinterpret_cast<LPARAM>(str.c_str()));

	}

	///	݂̑Isݒ^擾 (0 origin)
	LRESULT	SetCurSel(int nSel) {
		if ((int)GetList()->size() <= nSel) return -1; // ͈͊O
		::SendMessage(GetHWnd(),IsListBox()?LB_SETCURSEL:CB_SETCURSEL
			, (WPARAM)nSel, 0L);
		return 0;
	}
	///	i擾ꍇ́AIsȂ-1Ԃ)
	int GetCurSel() const {
		int nPos = ::SendMessage(GetHWnd(),IsListBox()?LB_GETCURSEL:CB_GETCURSEL
			,0L, 0L);
		return nPos;
	}

	///	ݑIĂꏊɂ镶擾
	string	GetSelectedString() const {
		int nPos = GetCurSel();
		if ((int)GetConstList()->size()<=nPos) {
			return "";
		} else {
			return (*GetConstList())[nPos];
		}
	}

	///	ݒ肳Ă镶SNA
	LRESULT	Clear(){
		HWND hWnd = GetHWnd();
		if (hWnd==NULL) return -1;
		::SendMessage(hWnd,
			IsListBox()?LB_RESETCONTENT:CB_RESETCONTENT,0,0L);
		GetList()->clear();
		return 0;
	}

	CListBoxInfo(HWND hWnd = NULL) : m_hWnd(hWnd),m_bListBox(true) {}
	
	///	RXgN^œnтꂽƂ̂߂ɃR{{bNX(Xg{bNX)
	///	hWndnĂ邽߂̃o
	void	SetHWnd(HWND hWnd) { m_hWnd = hWnd; }
	HWND	GetHWnd() const { return m_hWnd; }

	protected:
	mylist m_list;		//	ێĂ񃊃Xg
	HWND   m_hWnd;
	bool	m_bListBox; // true:listbox false:combobox
	};

	/**
		Xg{bNXorR{{bNXACListBoxInfoƊ֘AÂ
		bListBox : true == Xg{bNXł@false == R{{bNXł
	*/
	void	Attach(CDialogHelper::CListBoxInfo& info,int nEditControl,bool bListBox=true)
	{
		info.SetHWnd(GetHWnd(nEditControl));
		info.SetListBox(bListBox);
	}
	///--------------------------------------------------------

	///	---- ̂قA~ǉfHH ----

protected:
	IWindow* m_pWindow;	//	eWindow|C^ݒ肵Ă
	CMessagePooler m_vPooler; // bZ[WPooler

	void	hook(IWindow*pWin);
	void	unhook(IWindow*pWin);
};

class CMsgDlg {
/**
	bZ[W_CAOo͗p(ɃfobOp)
*/
public:
	void	Out(const string& caption,const string& message);
};

} // end of namespace Window
} // end of namespace yaneuraoGameSDK3rd

#endif
