/*
	factory_permutation	: NXup
		programmed & desinged by yaneurao(M.Isozaki) '02/03/07
*/

#ifndef __YTLfactory__
#define __YTLfactory__

namespace yaneuraoGameSDK3rd {
namespace YTL {

class factory_base {
/**
	factory ̊NX
*/
public:
	virtual void* Create()=0;
	virtual ~factory_base(){}
};

template <class T>
class factory : public factory_base {
/**
	factory
*/
public:
	virtual T* CreateInstance() { return new T; }
	virtual void* Create() { return new T; }
};

template <class T,class S>
class factory2 : public factory<T> {
///	T͊NXBS͂̔hNXB
	virtual T* CreateInstance() { return new S; }
	virtual void* Create() { return new S; }
};

///	TۃNX̂Ƃfactory
template <class T>
class factory_i : public factory_base {
/**
	factory
*/
public:
	virtual T* CreateInstance()=0;
	virtual void* Create()=0;
};

template <class T,class S>
class factory_i2 : public factory_i<T> {
///	T͊NX()BS͂̔hNXB
	virtual T* CreateInstance() { return new S; }
	virtual void* Create() { return new S; }
};

#endif

//////////////////////////////////////////////////////////////////

#ifndef __YTLfactory_permutation_h__
#define __YTLfactory_permutation_h__

#include "smart_ptr.h"

template <class T,class S>
class factory_permutation {
/**
	NXusȂ߂̃ev[gB

	fBtHgŁASNX𐶐B
	́AT̔hNXł邱ƁB

	SetFactorył́AT̔hNX̃|C^nB
	CreateInstanceĂяoƁAݕێĂfactoryɂ
	IuWFNg𐶐Asmart_ptrԂB

	TۃNX̂Ƃ:
		class factory_permutation_i
	p邱

	gpj
	factory_permutation<IHoge,CHogeSakura> f;
	//	CHogeSakuraIHogehNX
	//	fBtHgŁÃIuWFNg
	smart_ptr<IHoge> p = f.CreateInstance();
	//	΁ACHogeSakurãIuWFNg
	f.SetFactory((CHogeTomoyo*)0);
	//	IuWFNgIHogehNXłCHogeTomoyo
	//@ύXĂ݂
	smart_ptr<IHoge> p = f.CreateInstance();
	//	΁ACHogeTomoyõIuWFNg
	smart_ptr<factory<IHoge> > h = f.GetFactory();
	//	ł́Afactoryufactory<CHogeTomoyo>
	//	IuWFNg

*/
public:
	factory_permutation() :
	  m_vFactory(new factory2<T,S>){}

	///		factory̐ݒ^擾
	template <class U>
	void	SetFactory(const U*) {
	//	Ŏw肵Ăclass ÚAT̔hNXƉB
		m_vFactory.Add(new factory2<T,U>);
	}
	smart_ptr<factory<T> > GetFactory() const
	{ return m_vFactory; }

	///		factoryɂăCX^X̐
	smart_ptr<T> CreateInstance() {
		return smart_ptr<T>(m_vFactory->CreateInstance());
	}

protected:
	smart_ptr<factory<T> >	m_vFactory;
};

template <class T,class S>
class factory_permutation_i {
/**
	NXusȂ߂̃ev[gB
	class factory_permutation ̊NXTۃNX̂Ƃ
	o[W
*/
public:
	factory_permutation_i() :
	  m_vFactory(new factory_i2<T,S>){}

	///		factory̐ݒ^擾
	template <class U>
	void	SetFactory(const U*) {
	//	Ŏw肵Ăclass ÚAT̔hNXƉB
		m_vFactory.Add(new factory_i2<T,U>);
	}
	smart_ptr<factory_i<T> > GetFactory() const
	{ return m_vFactory; }

	///		factoryɂăCX^X̐
	smart_ptr<T> CreateInstance() {
		return smart_ptr<T>(m_vFactory->CreateInstance());
	}

protected:
	smart_ptr<factory_i<T> >	m_vFactory;
};

} // end of namespace YTL
} // end of namespace yaneuraoGameSDK3rd

#endif
